/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lookout;

/**
 *
 * @author connie
 */



import tablemodels.MenuTableModel;
import tablemodels.GroupTableModel;
import tablemodels.SearchTableModel;
import tablemodels.ProductTableModel;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import java.text.DecimalFormat;


import manager.*;
import products.*;
import maths.*;

import javax.swing.table.AbstractTableModel;
 
import java.util.Vector;


import javax.swing.*;
import java.awt.*;

import lookout.dndsupport.*;
import lookout.settings.ProgramSettings;

import java.awt.event.*;

import javax.swing.event.*;
import java.io.*;
import javax.swing.text.*;
import java.beans.*;


public class MainFrame extends JFrame implements ActionListener,
PropertyChangeListener, TableModelListener {
  
  //Actions name
  private static final String MOVE2MENU = "move to menu";
  private static final String MOVE2PROD = "move to prod";
  private static final String MOVE2GROUP = "move to group";
  private static final String MOVE2SNACK = "move to snack";
  //Colors
  private static final Color ALEX_GREEN = new Color(0,0x92,0x3F);
    
 // Введем сразу имена для кнопок - потом будем их использовать в обработчиках
  private static final String MOVE_GR_UP = "moveGroupUp";
  private static final String MOVE_GR_DOWN = "moveGroupDown";
  private static final String NEW_GR = "newGroup";
  private static final String EDIT_GR = "editGroup";
  private static final String DELETE_GR = "deleteGroup";
  
  private static final String NEW_PROD = "newProd";
  private static final String EDIT_PROD = "editProd";
  private static final String DELETE_PROD = "deleteProd";
  private static final String SEARCH_PROD = "searchProd";
  private static final String ADD_PROD_2_MENU = "add product to menu";
  private static final String ADD_PROD_2_SNACK = "add product to snack";
  
  private static final String COEF_CHANGED = "coefsChanged";
  
  private static final String CREATE_PROD_MENU = "createProdFormMenu";
  private static final String DELETE_PROD_FROM_MENU = "deleteProdFromMenu";
  private static final String FLUSH_MENU = "flushMenu";
  
  
  private static final String VALUE_CHANGED = "value";
  
  private static final String DO_SEARCH = "do search";
  private static final String CANCEL_SEARCH = "cancel search";
  
  
  private static final String PROD_PANE = "products panel";
  private static final String SEARCH_PANE = "search panel";

  private static final String SHOW_ABOUTBOX = "show about box";

  private static final String PROG_EXIT = "exitFromProg";

    private static final String USER_CONF_FILE = System.getProperty("user.home")+
            File.separator+".DCJonlineuser.conf";
  
  private static final String ROUND_DOSE = "round dose";
  public final static String [] ROUNDS = {"до целой дозы","до 0,5 ед.","до 0,25 ед.",
            "до 0,1 ед. - ручка NovoPen3","до 0,08(3) ед. - ручка NovoPen Demi",
            "0,05 ед. - помпа"};
  
    private JTable grpList = null;
    private JTable prodList = null;
    private JTable menuList = null;
    private JTable snackList = null;
    
    private DPS currDPS;
   
    private ProductManager prodMgr;
    private GroupManager groupMgr;
   
    
    //coef zone
    private JFormattedTextField fldK1=null;
    private JFormattedTextField fldK2=null;
    private JFormattedTextField fldK3=null;
    private JFormattedTextField fldXE=null;
    private JFormattedTextField fldSh1 = null;
    private JFormattedTextField fldSh2 = null;
    private JLabel lblXE = null;
    
    //result zone
    private JLabel lblDPS;
    private JLabel lblQuickDose;
    private JLabel lblSlowCarbDose;
    private JLabel lblProtFatDose;
    private JLabel lblDPSplusQD;
    private JLabel lblCarbDose;
    private JLabel lblSlowDose;
    private JLabel lblWholeDose;
    
    
    private JLabel lblCalorMenu;
    private JLabel lblProtMenu;
    private JLabel lblFatMenu;
    private JLabel lblCarbMenu;
    private JLabel lblGiMenu;
    private JLabel lblBEMenu;
    private JLabel lblGLMenu;
    
    //Форматирование вывода
    private FloatRenderer floatRenderer;
    private String [] precisionPattern = {"0.0","0.00","0.000"};

    private DecimalFormat df = new DecimalFormat("0");
    private DecimalFormat df0 = new DecimalFormat("0.0");
    private DecimalFormat df00 = new DecimalFormat("0.00");
    private NumberFormatter formatter0 = new NumberFormatter(df0);
    private JFormattedTextField cellField0 = new JFormattedTextField(formatter0);
    private FloatEditor cellEditor0 = new FloatEditor(cellField0, df0);
    
    private JSpinner sp;
    private ProdDialog prodDialog=null;
    
    private User user;
    
    private ProgramSettings settings;
    private JSplitPane prodSplitPane;
    private JPanel searchPane;
    private JTextField searchFld;
    private JTable searchTable;
    private JPanel productPanel;
    
   
    
    private boolean storeCoefs = true;
    private JSplitPane MenuProdPane;
    private JSplitPane menu_snack = null;

    private JProgressBar carbRatioMenu = null;
    private JProgressBar carbRatioSnack = null;

    private boolean baseIsChanged = false;

  public MainFrame(){
    super();
    setTitle("DiaCalcJ облегченная версия для online использования");
    //Сбацаем иконку
    setIconImage(new ImageIcon(MainFrame.class
            .getResource("images/MainIcon.png")).getImage());
    
    settings = ProgramSettings.getInstance();
    floatRenderer = new FloatRenderer("0.0");
    prodMgr = new ProductManager();
    
    userChanged();//загружаем все данные по пользователю
    
    //устанавливаем Layout для всей формы
    getContentPane().setLayout(new BorderLayout());
    
    groupMgr = new GroupManager();
 
    JPanel left = createGroupPane();
    
    //Формируем правую панель
    /////////////////////////////////////////////////////////////////////
    JPanel right = new JPanel(new BorderLayout());
            
    right.add(createProdPane(),BorderLayout.CENTER);
    right.setMinimumSize(new Dimension(200,200));
    
     
    
    prodSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                           left, right);
     
    prodSplitPane.setOneTouchExpandable(false);
    searchPane = createSearchPane();
    
    productPanel = new JPanel(new CardLayout());
    productPanel.add(prodSplitPane,PROD_PANE);
    productPanel.add(searchPane,SEARCH_PANE);
    
    
    prodSplitPane.setDividerLocation(settings.getIn().getGroupSize());
        
   
     MenuProdPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                           createMenuPane(), productPanel);
     MenuProdPane.setOneTouchExpandable(true);
     MenuProdPane.setDividerLocation(settings.getIn().getMenuSize());
     
     getContentPane().add(MenuProdPane,BorderLayout.CENTER);
     
     setJMenuBar(createMenu());
     
     //setSize(750,500);
     
     calcMenu();
     this.addWindowListener(new WindowAdapter(){
               @Override
               public void windowClosing(WindowEvent e){
                   //System.out.println("closing")  ;
                   exitFromProgram();
               }
            });
  }

  private void setActionMap(JComponent comp){
        comp.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_1,
                InputEvent.CTRL_DOWN_MASK ),MOVE2MENU);
        comp.getActionMap().put(MOVE2MENU, move2menu);
        comp.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_2,
                InputEvent.CTRL_DOWN_MASK ),MOVE2SNACK);
        comp.getActionMap().put(MOVE2SNACK, move2snack);
        comp.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_Q,
                InputEvent.CTRL_DOWN_MASK ),MOVE2GROUP);
        comp.getActionMap().put(MOVE2GROUP, move2group);
        comp.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_A,
                InputEvent.CTRL_DOWN_MASK ),MOVE2PROD);
        comp.getActionMap().put(MOVE2PROD, move2prod);
        
  }

  
  private JButton makeButton(String imageName, String altText, 
            String actionCommand, String toolTipText) {
        //Look for the image.
        String imgLocation =  "bttns/" + imageName + ".png";
        //URL imageURL = MainFrame.class.getResource(imgLocation);
       
        //Create and initialize the button.
        JButton button = new JButton();
        button.setToolTipText(toolTipText);
        button.setActionCommand(actionCommand);
        button.addActionListener(this);
        
        button.setIcon(loadImage(imgLocation));
        
        /*if (imageURL != null) {                      //image found
            button.setIcon(new ImageIcon(imageURL, altText));
        } else {                                     //no image found
            button.setText(altText);
            System.err.println("Resource not found: "
                               + imgLocation);
        }*/
        setActionMap(button);

        button.getInputMap().put(KeyStroke.getKeyStroke("ENTER"),
                            "pressed");
        button.getInputMap().put(KeyStroke.getKeyStroke("released ENTER"),
                            "released");
        button.getInputMap().put(KeyStroke.getKeyStroke("SPACE"),
                            "none");
        button.getInputMap().put(KeyStroke.getKeyStroke("released SPACE"),
                            "none");

        //Action pressed = button.getActionMap().get("pressed");
        //Action released = button.getActionMap().get("released");
        //button.getActionMap().put("pressed", pressed);
        //button.getActionMap().put("released", released);

        return button;
    }
  
  private JPanel createSearchPane(){
      JPanel res = new JPanel(new BorderLayout());
      
      JToolBar bar = new JToolBar();
      searchFld = new JTextField();
      searchFld.setActionCommand(DO_SEARCH);
      searchFld.addActionListener(this);
      JButton doSearch = makeButton("Search","Search",DO_SEARCH,
              "Искать продукт");
      JButton exitSearch = makeButton("CancelSrch","Cancel Search",CANCEL_SEARCH,
              "Закончить поиск");
      bar.add(searchFld);
      bar.addSeparator();
      bar.add(doSearch);
      bar.add(exitSearch);
      
      bar.setFloatable(false);
      
      
      searchTable = new JTable(new SearchTableModel());
      searchTable.setFillsViewportHeight(true);
      searchTable.getTableHeader().setReorderingAllowed(false);//запрещаем двигать столбцы

      searchTable.getColumnModel().getColumn(0).setPreferredWidth(300);
      searchTable.getColumnModel().getColumn(1).setPreferredWidth(400);
      searchTable.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      searchTable.addMouseListener(new MouseAdapter(){
          @Override
          public void mouseClicked(MouseEvent e) { 
             if (SwingUtilities.isLeftMouseButton(e) && 
                     e.getClickCount() % 2 == 0)  { doSelectionSeached(); }
          }
     });
      
    
     setActionMap(searchTable);
      
      res.add(bar, BorderLayout.NORTH);
      res.add(new JScrollPane(searchTable),BorderLayout.CENTER);
      
      
      return res;
  }
   
  private void reloadProducts(){
      if ( (prodList!= null) && (grpList.getRowCount()==0 || 
              (!grpList.getSelectionModel().isSelectionEmpty() &&
                    grpList.getRowCount()>0)
              )){

          int grId = 0;
          // Получаем выделенную группу
          if (!grpList.getSelectionModel().isSelectionEmpty()) {
              grId = ((ProdGroup) ((GroupTableModel)grpList.getModel())
                     .getGroup(grpList.getSelectedRow())).getId();
          }
          ((ProductTableModel)prodList.getModel()).reloadProducts(grId);
            
          
           if (prodList.getModel().getRowCount()>0) {
                prodList.getSelectionModel().setSelectionInterval(0, 0);
           }
           
        }
      
 } 
 

 @Override
 public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        // Handle each button.
        if (NEW_GR.equals(cmd)){
            addNewGroup();
        }
        else if (EDIT_GR.equals(cmd)){
            changeGroupName();
        }
        else if (DELETE_GR.equals(cmd)){
            deleteGroup();
        }
        else if (NEW_PROD.equals(cmd)){
            addNewProd();
        }
        else if (EDIT_PROD.equals(cmd)){
            editProduct();
        }
        else if (DELETE_PROD.equals(cmd)){
            deleteProduct();
        }
        else if (FLUSH_MENU.equals(cmd)){
            flushMenu();
        }
        else if (CREATE_PROD_MENU.equals(cmd)){
            createProductMenu();
        }
        
        else if (DELETE_PROD_FROM_MENU.equals(cmd)){
            deleteProdFromMenu();
        }
        else if (MOVE_GR_UP.equals(cmd)){
            moveGroupUp();
        }
        else if (MOVE_GR_DOWN.equals(cmd)){
            moveGroupDown();
        }
        
        else if (SEARCH_PROD.equals(cmd)){
            beginSearch();
        }
        else if (CANCEL_SEARCH.equals(cmd)){
            cancelSearch();
        }
        else if (DO_SEARCH.equals(cmd)){
            doSearch();
        }
        
        else if (SHOW_ABOUTBOX.equals(cmd)){
            showAboutBox();
        }
        else if (ROUND_DOSE.equals(cmd)){
            roundDose();
        }
        else if (ADD_PROD_2_MENU.equals(cmd)){
            addProdToMenu();
        }
        else if (ADD_PROD_2_SNACK.equals(cmd)){
            addProdToSnack();
        }
        else if (PROG_EXIT.equals(cmd)) {
            exitFromProgram();
        }
        
}
private void exitFromProgram(){
    if (baseIsChanged){
       ManagementSystem.getInstance()
                    .saveBase(groupMgr.getGroups(settings.getIn().useUsageGroup()),
                        prodMgr.getAllProducts());
    }
    saveUser();
    setVisible(false);
    MainFrame.this.dispose();
}
 private JPanel createCharPane(){//панелька с характеристиками еды
     JPanel CharPane = new JPanel(new GridBagLayout());
     Border brdr = BorderFactory.createLineBorder(Color.GRAY);
     
     ////////БЖУ
     JLabel lbl = new JLabel("Б");
     CharPane.add(lbl,
             new GridBagConstraints(0,0,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE,  new Insets(2,2,0,1), 0, 0));
     
     lblProtMenu = new JLabel("===");
     lblProtMenu.setBorder(brdr);
     lblProtMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblProtMenu.setToolTipText("Кооличество белков в еде");
     CharPane.add(lblProtMenu,
             new GridBagConstraints(1,0,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(2,1,0,2) , 0, 0));
     
     
     lbl = new JLabel("Ж");
     CharPane.add(lbl,
          new GridBagConstraints(0,1,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE, new Insets(2,2,0,1) , 0, 0));
     
     lblFatMenu = new JLabel("===");
     lblFatMenu.setBorder(brdr);
     lblFatMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblFatMenu.setToolTipText("Количество жиров в еде");
     CharPane.add(lblFatMenu,
          new GridBagConstraints(1,1,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(2,1,0,2) , 0, 0));
     
     
     lbl = new JLabel("У");
     CharPane.add(lbl,
          new GridBagConstraints(0,2,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE, new Insets(2,2,0,1) , 0, 0));
     
     lblCarbMenu = new JLabel(("==="));
     lblCarbMenu.setBorder(brdr);
     lblCarbMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblCarbMenu.setToolTipText(("Количество углеводов в еде"));
     CharPane.add(lblCarbMenu,
          new GridBagConstraints(1,2,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(2,1,0,2) , 0, 0));
     //////Делаем разрыв
     lbl = new JLabel(("Кал"));
     CharPane.add(lbl,
             new GridBagConstraints(0,3,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE, new Insets(4,2,0,1) , 0, 0));

     lblCalorMenu = new JLabel(("===="));
     lblCalorMenu.setBorder(brdr);
     lblCalorMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblCalorMenu.setToolTipText(("Калорийность еды"));
     CharPane.add(lblCalorMenu,
             new GridBagConstraints(1,3,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(4,1,0,2) , 0, 0));

     ///небольшой разрыв

     lbl = new  JLabel("ГИ");
     CharPane.add(lbl,
          new GridBagConstraints(0,4,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE, new Insets(4,2,0,1) , 0, 0));
     
     lblGiMenu = new JLabel("==");
     lblGiMenu.setBorder(brdr);
     lblGiMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblGiMenu.setToolTipText(("Гликемический индекс еды"));
     CharPane.add(lblGiMenu,
          new GridBagConstraints(1,4,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(4,1,0,2) , 0, 0));

     lbl = new JLabel("ГН");
     CharPane.add(lbl,
          new GridBagConstraints(0,5,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE, new Insets(2,2,0,1) , 0, 0));

     lblGLMenu = new JLabel("===");
     lblGLMenu.setBorder(brdr);
     lblGLMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblGLMenu.setToolTipText(("Гликемическая нагрузка еды"));
     CharPane.add(lblGLMenu,
          new GridBagConstraints(1,5,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(2,1,0,2) , 0, 0));
     
     lbl = new JLabel("ХЕ");
     CharPane.add(lbl,
          new GridBagConstraints(0,6,1,1,0.2,0, GridBagConstraints.LINE_START,
          GridBagConstraints.NONE, new Insets(4,2,2,2) , 0, 0));
     
     lblBEMenu = new JLabel("===");
     lblBEMenu.setBorder(brdr);
     lblBEMenu.setHorizontalAlignment(SwingConstants.CENTER);
     lblBEMenu.setToolTipText(("Количество ХЕ в еде"));
     CharPane.add(lblBEMenu,
          new GridBagConstraints(1,6,1,1,0.8,0, GridBagConstraints.CENTER,
          GridBagConstraints.HORIZONTAL, new Insets(4,1,2,2) , 0, 0));
  
     brdr = BorderFactory.createLineBorder(Color.GRAY);
     CharPane.setBorder(brdr);
     
     
     return CharPane;
 }
 
 private JPanel createDosesPane(){
     JPanel DosesPane = new JPanel(new GridBagLayout());
     Border brdr = BorderFactory.createLineBorder(Color.GRAY);
     Border brdrRsd = BorderFactory.createBevelBorder(0);
  
     Insets in = new Insets(2,2,2,2);
     
     JLabel lbl = new JLabel(("ДПС"));
     lbl.setHorizontalAlignment(SwingConstants.CENTER);
     DosesPane.add(lbl,
          new GridBagConstraints(0,0,1,1,0.8,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     lbl = new JLabel(("БД"));
     lbl.setHorizontalAlignment(SwingConstants.CENTER);
     DosesPane.add(lbl,
          new GridBagConstraints(1,0,1,1,0.8,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     lbl = new JLabel(("МД угл."));
     lbl.setHorizontalAlignment(SwingConstants.CENTER);
     DosesPane.add(lbl,
          new GridBagConstraints(2,0,1,1,0.4,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     lbl = new JLabel(("МД б/ж."));
     lbl.setHorizontalAlignment(SwingConstants.CENTER);
     DosesPane.add(lbl,
          new GridBagConstraints(3,0,1,1,0.4,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     Color Olive = new Color(0x45928B);
     lblDPS = new JLabel((""));
     lblDPS.setHorizontalAlignment(SwingConstants.CENTER);
     lblDPS.setBorder(brdr);
     lblDPS.setForeground(Olive);
     lblDPS.setToolTipText(("Доза на снижение сахара крови"));
     DosesPane.add(lblDPS,
          new GridBagConstraints(0,1,1,1,0.8,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     lblQuickDose = new JLabel((""));
     lblQuickDose.setHorizontalAlignment(SwingConstants.CENTER);
     lblQuickDose.setBorder(brdr);
     lblQuickDose.setForeground(Olive);
     lblQuickDose.setToolTipText(("Доза на быструю часть углеводов"));
     DosesPane.add(lblQuickDose,
          new GridBagConstraints(1,1,1,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
          
     lblSlowCarbDose = new JLabel((""));
     lblSlowCarbDose.setHorizontalAlignment(SwingConstants.CENTER);
     lblSlowCarbDose.setBorder(brdr);
     lblSlowCarbDose.setForeground(Olive);
     lblSlowCarbDose.setToolTipText(("Доза на медленную часть углеводов"));
     DosesPane.add(lblSlowCarbDose,
          new GridBagConstraints(2,1,1,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     lblProtFatDose = new JLabel((""));
     lblProtFatDose.setHorizontalAlignment(SwingConstants.CENTER);
     lblProtFatDose.setBorder(brdr);
     lblProtFatDose.setForeground(Olive);
     lblProtFatDose.setToolTipText(("Доза на белки и жиры"));
     DosesPane.add(lblProtFatDose,
          new GridBagConstraints(3,1,1,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     lblDPSplusQD = new JLabel((""));
     lblDPSplusQD.setHorizontalAlignment(SwingConstants.CENTER);
     lblDPSplusQD.setBorder(brdrRsd);
     lblDPSplusQD.setToolTipText(("Доза на снижение сахара крови " +
             "и быстрая часть дозы"));
     DosesPane.add(lblDPSplusQD,
          new GridBagConstraints(0,2,2,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     lblSlowDose = new JLabel((""));
     lblSlowDose.setHorizontalAlignment(SwingConstants.CENTER);
     lblSlowDose.setBorder(brdrRsd);
     lblSlowDose.setToolTipText(("Медленная часть дозы"));
     DosesPane.add(lblSlowDose,
          new GridBagConstraints(2,2,2,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     lblCarbDose = new JLabel((""));
     lblCarbDose.setHorizontalAlignment(SwingConstants.CENTER);
     lblCarbDose.setBorder(brdr);
     Color DarkGreen = new Color(0x228614);
     lblCarbDose.setForeground(DarkGreen);
     lblCarbDose.setToolTipText(("Доза на углеводы и на снижение сахара крови"));
     DosesPane.add(lblCarbDose,
          new GridBagConstraints(0,3,3,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
     
     TitledBorder titled = BorderFactory.createTitledBorder(brdrRsd,"вся доза");
     //titled.setBorder(brdr);
     lblWholeDose = new JLabel((""));
     lblWholeDose.setHorizontalAlignment(SwingConstants.CENTER);
     lblWholeDose.setBorder(titled);
     lblWholeDose.setToolTipText(("Полная доза"));
     DosesPane.add(lblWholeDose,
          new GridBagConstraints(2,4,2,1,0.5,0, GridBagConstraints.BELOW_BASELINE, 
          GridBagConstraints.HORIZONTAL, in , 0, 0));
          
     //brdr = BorderFactory.createLineBorder(Color.GRAY);
     //DosesPane.setBorder(brdr);
     return DosesPane;
 }
 
 @Override
 public void propertyChange(PropertyChangeEvent e) {
      String propName = e.getPropertyName();
      //System.out.println(propName);
      if (VALUE_CHANGED.equals(propName)){
        if (e.getSource() instanceof JFormattedTextField){
               // System.out.println("Property changed - calcMenu");
                if (storeCoefs){
                    if (e.getSource()==fldK1 && settings.getIn().shouldCalcOUVbyK1() ){
                        float k1_10;
                        if (user.isDirect()){
                            k1_10 = 10f/((Number)fldK1.getValue()).floatValue();
                        } else{
                            k1_10 = ((Number)fldK1.getValue()).floatValue() * 10f /
                                user.getFactors().getBE(user.isDirect());
                        }
                        storeCoefs=false;
                        fldK3.setValue(new Sugar(user.getOUVcoef() / (user.getWeight()*k1_10))
                                .getSugar(user.isMmol(), user.isPlasma()));
                        storeCoefs=true;
                    }
                    user.getFactors().setK1XE(((Number)fldK1.getValue()).floatValue(),
                            ((Number)fldXE.getValue()).floatValue(),user.isDirect() );
                    
                    user.getFactors().setK2(((Number)fldK2.getValue()).floatValue());
                    Sugar s = new Sugar();
                    s.setSugar(((Number)fldK3.getValue()).floatValue(), user.isMmol(),user.isPlasma());
                    user.getFactors().setK3(s.getValue());

                    user.getSh1().setSugar(((Number)fldSh1.getValue()).floatValue(),
                            user.isMmol(),user.isPlasma());
                    user.getSh2().setSugar(((Number)fldSh2.getValue()).floatValue(), 
                            user.isMmol(),user.isPlasma());

                    currDPS.setSh1(user.getSh1());
                    currDPS.setSh2(user.getSh2());
                    currDPS.setFs(user.getFactors());
                    
                    ((MenuTableModel)menuList.getModel()).setFactors(user.getFactors());

                    calcMenu();

                }
        }
      }
      
      
    }
  
 private void calcMenu(){
     DecimalFormat frt = new DecimalFormat(precisionPattern[((Number)sp.getValue()).intValue()-1]);
     
     float carbAll = 0;
     float carbMenu = 0;
     //float carbSnack = 0;

     ProductW prod = ((MenuTableModel)menuList.getModel()).getSumProd();
     carbMenu = prod.getAllCarb();

     if (snackList!=null) prod.plusProd(((MenuTableModel)snackList.getModel()).getSumProd());
     carbAll = prod.getAllCarb();
     //carbSnack = carbAll - carbMenu;

     if (carbRatioMenu!=null){
         if (carbAll==0f){
             carbRatioMenu.setValue(0);
             carbRatioMenu.setString("");
             carbRatioSnack.setValue(100);
             carbRatioSnack.setString("");
         }
         else{
             carbRatioMenu.setValue( (int)(100f*carbMenu/carbAll) );
             ProductW menu = ((MenuTableModel)menuList.getModel()).getSumProd();
             carbRatioMenu.setString("Б:"+df0.format(menu.getAllProt())+
                     " Ж:"+df0.format(menu.getAllFat())+
                     " У:"+df0.format(menu.getAllCarb())+
                     " | ГИ "+menu.getGi() + " | ГН "+df0.format(menu.getGL()));
             carbRatioSnack.setValue( (int)(100f*carbMenu/carbAll) );
             menu = ((MenuTableModel)snackList.getModel()).getSumProd();
             carbRatioSnack.setString("Б:"+df0.format(menu.getAllProt())+
                     " Ж:"+df0.format(menu.getAllFat())+
                     " У:"+df0.format(menu.getAllCarb())+
                     " | ГИ "+menu.getGi() + " | ГН "+df0.format(menu.getGL()));
         }
     }
     Dose ds = new Dose(prod, user.getFactors(), currDPS);
     
     lblDPS.setText((frt.format(ds.getDPSDose())));
     lblQuickDose.setText((frt.format(ds.getCarbFastDose())));
     lblSlowCarbDose.setText((frt.format(ds.getCarbSlowDose())));
     lblProtFatDose.setText((frt.format(ds.getSlowDose())));
     //ДПС и быстрая доза
     lblDPSplusQD.setText((frt.format(ds.getDPSDose()+ds.getCarbFastDose())));
     //вся доза углеводов
     lblCarbDose.setText((frt.format(ds.getCarbFastDose()+ds.getCarbSlowDose()
             +currDPS.getDPSDose())));
     lblSlowDose.setText((frt.format(ds.getCarbSlowDose()+ds.getSlowDose())));
     lblWholeDose.setText((frt.format(ds.getWholeDose())));
     
     
     frt =  new DecimalFormat("0");
     lblCalorMenu.setText((frt.format(ds.getCalories())));
     lblGiMenu.setText((frt.format(prod.getGi())));
     frt =  new DecimalFormat("0.0");
     lblProtMenu.setText((frt.format(prod.getAllProt())));
     lblFatMenu.setText((frt.format(prod.getAllFat())));
     lblCarbMenu.setText((frt.format(prod.getAllCarb())));
     if (user.isDirect()) lblBEMenu.setText(("==="));
     else lblBEMenu.setText((frt.format(prod
             .getAllCarb()/user.getFactors().getBE(user.isDirect()))));
     lblGLMenu.setText((frt.format( prod.getGL() )) );
  }
 
 class MyMainFocusListener implements FocusListener{
         public void focusGained(final FocusEvent arg0) {                
            SwingUtilities.invokeLater(new Runnable(){
            public void run(){
            ((JTextField)arg0.getSource()).selectAll();}
                
             });
            }
            public void focusLost(FocusEvent arg0) {
                
            }    
 }
 
 
 private JPanel createCoefPane(){
     JPanel CoefPane = new JPanel(new GridBagLayout());
     
     MyFocusListener fcLst = new MyFocusListener();
     MyMouseAdapter msad = new MyMouseAdapter();
     MyActionListener mal = new MyActionListener(false);
     PositiveFloatVerifier piv = new PositiveFloatVerifier(false);
     
     JLabel lblK1 = new JLabel(("k1"));
     lblK1.setAlignmentX(Component.RIGHT_ALIGNMENT);
     fldK1 = new JFormattedTextField(df00);
     fldK1.setColumns(3);
     
     fldK1.setInputVerifier(piv);
     fldK1.addFocusListener(fcLst);
     fldK1.addMouseListener(msad);
     fldK1.addActionListener(mal);
     fldK1.addPropertyChangeListener("value", this);
     fldK1.setActionCommand(COEF_CHANGED);
     fldK1.setToolTipText(("Коэффициент чувствительности к углеводам"));
     setActionMap(fldK1);
     
     JLabel lblK2 = new JLabel(("k2"));
     fldK2 = new JFormattedTextField(df00);
     
     fldK2.setColumns(3);
     fldK2.setInputVerifier(piv);
     fldK2.addFocusListener(fcLst);
     fldK2.addMouseListener(msad);
     fldK2.addActionListener(mal);
     fldK2.addPropertyChangeListener("value", this);
     fldK2.setActionCommand(COEF_CHANGED);
     fldK2.setToolTipText(("Коэффициент чувствительности к белкам и жирам"));
     setActionMap(fldK2);
     
     JLabel lblK3 = new JLabel(("ЦЕИ"));
     fldK3 = new JFormattedTextField(df00);
     
     fldK3.setColumns(3);
     fldK3.setInputVerifier(piv);
     fldK3.addFocusListener(fcLst);
     fldK3.addMouseListener(msad);
     fldK3.addActionListener(mal);
     fldK3.addPropertyChangeListener("value", this);
     fldK3.setActionCommand(COEF_CHANGED);
     fldK3.setToolTipText(("Чувствительность к инсулину"));
     setActionMap(fldK3);
     
     lblXE = new JLabel("Вес ХЕ");
          
     //вторая строчка
     JLabel lblSh1 = new JLabel(("Нач. СК"));
     fldSh1 = new JFormattedTextField(df0);
     fldSh1.setValue(user.getTargetSh().getSugar(user.isMmol(),user.isPlasma()));
     fldSh1.setColumns(3);
     fldSh1.setInputVerifier(piv);
     fldSh1.addFocusListener(fcLst);
     fldSh1.addMouseListener(msad);
     fldSh1.addActionListener(mal);
     fldSh1.addPropertyChangeListener("value", this);
     fldSh1.setActionCommand(COEF_CHANGED);
     fldSh1.setToolTipText(("Стартовый сахар крови"));
     setActionMap(fldSh1);
     
     JLabel lblSh2 = new JLabel(("Цель СК"));
     fldSh2 = new JFormattedTextField(df0);
     fldSh2.setValue(user.getTargetSh().getSugar(user.isMmol(),user.isPlasma()));
     fldSh2.setColumns(3);
     fldSh2.setInputVerifier(piv);
     fldSh2.addFocusListener(fcLst);
     fldSh2.addMouseListener(msad);
     fldSh2.addActionListener(mal);
     fldSh2.addPropertyChangeListener("value", this);
     fldSh2.setActionCommand(COEF_CHANGED);
     fldSh2.setToolTipText(("Желаемый сахар крови"));
     setActionMap(fldSh2);
         
     fldXE = new JFormattedTextField(df0);
     fldXE.setColumns(4);
     fldXE.setValue(user.getFactors().getBE(user.isDirect()));
     fldXE.setInputVerifier(piv);
     fldXE.addFocusListener(fcLst);
     fldXE.addMouseListener(msad);
     fldXE.addActionListener(mal);
     fldXE.addPropertyChangeListener("value", this);
     fldXE.setActionCommand(COEF_CHANGED);
     fldXE.setToolTipText(("Вес ХЕ в граммах"));
     setActionMap(fldXE);
     
     
     JPanel top =  new JPanel();
     top.setLayout(new BoxLayout(top, BoxLayout.LINE_AXIS));
     
     CoefPane.add(lblK1,
          new GridBagConstraints(0,0,1,1,0.1,0, GridBagConstraints.LINE_END,
          GridBagConstraints.NONE, new Insets(5,5,2,4), 0, 0));
     CoefPane.add(fldK1,
           new GridBagConstraints(1,0,1,1,0.5,0, GridBagConstraints.BELOW_BASELINE,
           GridBagConstraints.HORIZONTAL, new Insets(5,0,2,0), 0, 0 ));
     CoefPane.add(lblK2,
            new GridBagConstraints(2,0,1,1,0.1,0, GridBagConstraints.LINE_END,
           GridBagConstraints.NONE, new Insets(5,4,2,4), 0,0   ));
     CoefPane.add(fldK2,
            new GridBagConstraints(3,0,1,1,0.5,0, GridBagConstraints.BELOW_BASELINE,
            GridBagConstraints.HORIZONTAL,new Insets(5,0,2,0), 0,0 ));
     CoefPane.add(lblK3,
             new GridBagConstraints(4,0,1,1,0.1,0,GridBagConstraints.LINE_END,
             GridBagConstraints.NONE, new Insets(5,4,2,4), 0,0 ));
     CoefPane.add(fldK3,
             new GridBagConstraints(5,0,1,1,0.5,0, GridBagConstraints.BELOW_BASELINE,
             GridBagConstraints.HORIZONTAL,new Insets(5,0,2,0), 0,0 ));
     CoefPane.add(lblXE,
             new GridBagConstraints(6,0,1,1,0.3,0, GridBagConstraints.BELOW_BASELINE,
             GridBagConstraints.HORIZONTAL, new Insets(2,4,5,5), 0,0 ));
    
     CoefPane.add(lblSh1,
             new GridBagConstraints(0,1,2,1,0.2,0,GridBagConstraints.LINE_END,
             GridBagConstraints.NONE, new Insets(2,5,5,4), 0,0 ));
     CoefPane.add(fldSh1,
             new GridBagConstraints(2,1,1,1,0.4,0,GridBagConstraints.BELOW_BASELINE,
             GridBagConstraints.HORIZONTAL, new Insets(2,0,5,4), 0,0 ));
     CoefPane.add(lblSh2,
             new GridBagConstraints(3,1,2,1,0.2,0,GridBagConstraints.LINE_END,
             GridBagConstraints.NONE, new Insets(2,5,5,4), 0,0 ));
     CoefPane.add(fldSh2,
             new GridBagConstraints(5,1,1,1,0.4,0,GridBagConstraints.BELOW_BASELINE,
             GridBagConstraints.HORIZONTAL, new Insets(2,0,5,4), 0,0 ));
     CoefPane.add(fldXE,
             new GridBagConstraints(6,1,1,1,0.3,0, GridBagConstraints.BELOW_BASELINE,
             GridBagConstraints.HORIZONTAL, new Insets(2,4,5,5), 0,0 ));
     
     storeCoefs = false;
     
     fldK1.setValue(user.getFactors().getK1(user.isDirect()));
     fldK2.setValue(user.getFactors().getK2());
     fldK3.setValue(new Sugar(user.getFactors().getK3()).getSugar(user.isMmol(),user.isPlasma()));
     //вот тут нужно делать через Sugar
     fldXE.setValue(user.getFactors().getBE(user.isDirect()));

     
     storeCoefs = true;
     
     CoefPane.setBorder(BorderFactory.createLineBorder(Color.GRAY));
     return CoefPane;
 }
 
 private JComponent createProdPane(){
     JToolBar bar = new JToolBar();
     //здесь формируем зону базы продуктов
     bar.add(makeButton("New","NP",NEW_PROD,("Добавить продукт")));
     bar.add(makeButton("Edit","EP",EDIT_PROD,("Изменить продукт")));
    
     bar.addSeparator();
     
     bar.add(makeButton("Search","SC",SEARCH_PROD,("Искать продукт")));
    
     bar.addSeparator();
     
     
     bar.add(makeButton("Delete","DL",DELETE_PROD,("Удалить продукт")));
    
     bar.setFloatable(false);
    
     // И устанавливаем модель для таблицы с новыми данными
     ProdGroup gr;
     
     if (grpList.getRowCount()>0){
       gr = (ProdGroup) ((GroupTableModel)grpList.getModel())
             .getGroup(grpList.getSelectedRow());
     }
     else gr = new ProdGroup();
     final JTextField test_field = new JTextField();
     

     prodList = new JTable(new ProductTableModel(prodMgr,
             gr.getId())){
    //Implement table cell tool tips.
         
     @Override
     public String getToolTipText(MouseEvent e) {
        String tip = null;
        java.awt.Point p = e.getPoint();
        int rowIndex = rowAtPoint(p);
        int colIndex = columnAtPoint(p);
        if (rowIndex>=0 && colIndex>=0){

        ProductInBase prod = ((ProductTableModel)getModel()).getProduct(rowIndex);
        tip = prod.getName();

        test_field.setText(tip);
        int width = test_field.getPreferredSize().width;
        if (width<=(prodList.getColumnModel().getColumn(0).getWidth()-5)) return null;
        //tip = (tip);
        }
        return tip;
     }
    };
    
     prodList.setAutoCreateRowSorter(true);//дополняем сортировку
     prodList.setFillsViewportHeight(true);//заполняем всю область
     prodList.getTableHeader().setReorderingAllowed(false);//запрещаем двигать столбцы
     
     for (int i=0;i<prodList.getColumnCount();i++){
          if (i==0){
              prodList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getProdName());
          }
          else{
              prodList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getProdRest());
          }
      }
    
     
     if (prodList.getModel().getRowCount()>0) prodList.getSelectionModel().setSelectionInterval(0, 0);
     
     prodList.setDefaultRenderer(Float.class, floatRenderer);
     prodList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     prodList.addMouseListener(new MouseAdapter(){
          @Override
          public void mouseClicked(MouseEvent e) { 
             if (SwingUtilities.isLeftMouseButton(e) && 
                     e.getClickCount() % 2 == 0)  { addProdToMenu(); }
          }
     });

     prodList.setTransferHandler(new ProdTableExportHandler());
     prodList.setDragEnabled(true);

     prodList.addKeyListener(new KeyAdapter(){
         @Override
         public void keyReleased(KeyEvent e){
             if (e.getModifiersEx()==0){
                if (e.getKeyCode()==KeyEvent.VK_INSERT){
                    addNewProd();
                }else if (e.getKeyCode()==KeyEvent.VK_DELETE){
                    deleteProduct();
                }else if (e.getKeyCode()==KeyEvent.VK_F4){
                    editProduct();
                }else if (e.getKeyCode()==KeyEvent.VK_F7){
                    beginSearch();
                }else if (e.getKeyCode()==KeyEvent.VK_M){
                    addProdToMenu();
                }else if (e.getKeyCode()==KeyEvent.VK_S){
                    addProdToSnack();
                }

             }
         }
     });
     setActionMap(prodList);

     

    JPopupMenu popup = new JPopupMenu();
    JMenuItem menuItem = new JMenuItem("Добавить в меню");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_M, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(ADD_PROD_2_MENU);
    popup.add(menuItem);

    menuItem = new JMenuItem("Добавить в перекус");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_S, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(ADD_PROD_2_SNACK);
    popup.add(menuItem);
    popup.addSeparator();

    menuItem = new JMenuItem("Поиск продукта");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_F7, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(SEARCH_PROD);
    popup.add(menuItem);
    popup.addSeparator();

    menuItem = new JMenuItem("Изменить продукт");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_F4, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(EDIT_PROD);
    popup.add(menuItem);
    menuItem = new JMenuItem("Создать продукт");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_INSERT, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(NEW_PROD);
    popup.add(menuItem);
    popup.addSeparator();

    menuItem = new JMenuItem("Удалить продукт");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_DELETE, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(DELETE_PROD);
    popup.add(menuItem);

    //prodList.setComponentPopupMenu(popup);
    prodList.addMouseListener(new PopupListener(popup));

     JPanel top = new JPanel(new BorderLayout());
     top.add(bar,BorderLayout.NORTH);
     top.add(new JScrollPane(prodList),BorderLayout.CENTER);
    
      //Здесь формируем зону сложного продукта
     return top;
 }
 
 

 private JPanel createGroupPane(){
     JPanel grpPane = new JPanel(new BorderLayout());
     grpPane.setPreferredSize(new Dimension(200, 0));
     
      JToolBar bar = new JToolBar();
          
       bar.add(makeButton("New","NW",NEW_GR,("Создать группу")));
       bar.add(makeButton("Edit","ED",EDIT_GR,("Изменить наименование группы")));
    
       bar.addSeparator();
       
       bar.add(makeButton("Up","UP",MOVE_GR_UP,("Переместить группу вверх")));
       bar.add(makeButton("Down","DWN",MOVE_GR_DOWN,("Переместить группу вниз")));
    
       bar.addSeparator();
       
       bar.add(makeButton("Delete","Dl",DELETE_GR,("Удалить группу")));
    
       bar.setFloatable(false);
    
    //Тут добавляем список и label для групп
    
    
    // Создаем визуальный список и вставляем его в скроллируемую
    // панель, которую в свою очередь уже кладем на панель left
       grpList = new JTable(new GroupTableModel(groupMgr));
       grpList.setFillsViewportHeight(true);
       grpList.getTableHeader().setReorderingAllowed(false);//запрещаем двигать столбцы
    
       grpList.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
           @Override
           public void valueChanged(ListSelectionEvent event) {
                if (!event.getValueIsAdjusting()){
                    reloadProducts();
                    //System.out.println("Выбрали группу");
                }
                
            }});
       grpList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
       grpList.setTransferHandler(new GroupMoveHandler());
       grpList.setDropMode(DropMode.ON);
       
       if (grpList.getRowCount()>0) grpList.getSelectionModel().setSelectionInterval(0, 0);
    
       grpList.addKeyListener(new KeyAdapter(){
           @Override
           public void keyReleased(KeyEvent e){
               if (e.getModifiersEx()==0){
                if (e.getKeyCode()==KeyEvent.VK_INSERT){
                   addNewGroup();
                } else if (e.getKeyCode()==KeyEvent.VK_F4){
                   changeGroupName();
                }else if (e.getKeyCode()==KeyEvent.VK_DELETE){
                   deleteGroup();
                }
               }
           }
       });
       
       setActionMap(grpList);

    JPopupMenu popup = new JPopupMenu();
    JMenuItem menuItem = new JMenuItem("Вверх");
    menuItem.addActionListener(this);
    menuItem.setActionCommand(MOVE_GR_UP);
    popup.add(menuItem);
    menuItem = new JMenuItem("Вниз");
    menuItem.addActionListener(this);
    menuItem.setActionCommand(MOVE_GR_DOWN);
    popup.add(menuItem);
    popup.addSeparator();

    menuItem = new JMenuItem("Изменить имя группы");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_F4, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(EDIT_GR);
    popup.add(menuItem);
    menuItem = new JMenuItem("Создать группу");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_INSERT, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(NEW_GR);
    popup.add(menuItem);
    popup.addSeparator();

    menuItem = new JMenuItem("Удалить группу");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_DELETE, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(DELETE_GR);
    popup.add(menuItem);
    

    //Add listener to components that can bring up popup menus.
    //grpList.addMouseListener(new PopupListener(popup));
    //grpList.setComponentPopupMenu(popup);
    grpList.addMouseListener(new PopupListener(popup));

      grpPane.add(bar,BorderLayout.NORTH); //Добавили бар
      grpPane.add(new JScrollPane(grpList),BorderLayout.CENTER);//Добавили панель со списком
 
     
     return grpPane;
 }

 private JPanel createMenuPane(){
     JPanel menuPane = new JPanel(new BorderLayout());
    //Создаем бар для зоны меню
    JToolBar bar = new JToolBar();
        
    bar.add(makeButton("New","NP",CREATE_PROD_MENU,("Создать новый продукт")));
    
    bar.addSeparator();
    
    
    bar.add(makeButton("Delete","DL",DELETE_PROD_FROM_MENU,("Удалить продукт из меню")));
    JButton btn = makeButton("Flush","FL",FLUSH_MENU,("Очистить меню"));
    Dimension d = btn.getPreferredSize();
    bar.add(btn);
    
    
    SpinnerModel spModel =
        new SpinnerNumberModel(1, //initial value
                               1, //min
                               3, //max
                               1);                //step
    sp = new JSpinner(spModel);
    d.width += 3;
    sp.setMaximumSize(d);
    sp.setValue(1);
    sp.addChangeListener(new ChangeListener(){
                @Override
                public void stateChanged(ChangeEvent e) {
                     calcMenu();
                }
    });
    
    setActionMap(sp);
    bar.add(sp);
    
    bar.setFloatable(false);
    
    JPanel menuTblPane = new JPanel(new BorderLayout());//зона таблицы и бара
    menuPane.add(bar,BorderLayout.NORTH);
        
    JPanel menuCalcPane = new JPanel(new GridBagLayout());//зона расчетов

    JPopupMenu popup = new JPopupMenu();
    JMenuItem menuItem = new JMenuItem("Округлить дозу");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_R, InputEvent.CTRL_DOWN_MASK));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(ROUND_DOSE);
    popup.add(menuItem);
    popup.addSeparator();
    menuItem = new JMenuItem("Удалить продукт");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_DELETE, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(DELETE_PROD_FROM_MENU);
    popup.add(menuItem);
    menuItem = new JMenuItem("Очистить меню");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_DELETE, InputEvent.CTRL_DOWN_MASK));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(FLUSH_MENU);
    popup.add(menuItem);
    popup.addSeparator();
    menuItem = new JMenuItem("Создать новый продукт");
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_INSERT, 0));
    menuItem.addActionListener(this);
    menuItem.setActionCommand(CREATE_PROD_MENU);
    popup.add(menuItem);
    

    //Add listener to components that can bring up popup menus.
    //MouseListener popupListener = new PopupListener(popup);
    MouseListener popupListener = new PopupListener(popup);

    KeyAdapter menuKeyAdapter = new KeyAdapter(){
         @Override
         public void keyReleased(KeyEvent e){
             if (e.getKeyCode()==KeyEvent.VK_INSERT){
                 if (e.getModifiersEx()==0){
                     createProductMenu();
                 }
             }else if (e.getKeyCode()==KeyEvent.VK_DELETE){
                 if (e.getModifiersEx()==0){
                     deleteProdFromMenu();
                 }else if ( (e.getModifiersEx()&InputEvent.CTRL_DOWN_MASK)==
                         InputEvent.CTRL_DOWN_MASK ){
                    flushMenu();
                 }
             }else if (e.getKeyCode()==KeyEvent.VK_R &&
                     (e.getModifiersEx()&InputEvent.CTRL_DOWN_MASK)==
                         InputEvent.CTRL_DOWN_MASK){
                 roundDose();
             }
         }
     };

    menuList = new JTable(new MenuTableModel(1,
            user.getFactors(),MenuTableModel.MENU_TABLE)){
    //Implement table cell tool tips.
     @Override
     public String getToolTipText(MouseEvent e) {
        String tip = null;
        java.awt.Point p = e.getPoint();
        int rowIndex = rowAtPoint(p);
        int colIndex = columnAtPoint(p);
        if (rowIndex>=0 && colIndex>=0){
        
        ProductInMenu prod = ((MenuTableModel)getModel()).getProduct(rowIndex);
        tip = prod.getName() + "<br>";
        DecimalFormat fr = new DecimalFormat("0.0");
        tip += "Вес: " + fr.format(prod.getWeight()) + "<br>" +
                " Б: " + fr.format(prod.getAllProt()) +
                " Ж: " + fr.format(prod.getAllFat()) +
                " У: " + fr.format(prod.getAllCarb()) +
                " ГИ: " + prod.getGi();

        
        }
        return tip;
     }
    };

    menuList.addKeyListener(menuKeyAdapter);
    
    menuList.setDefaultRenderer(Float.class, floatRenderer);
    menuList.getColumnModel().getColumn(1).setCellEditor(cellEditor0);
    
    menuList.setAutoCreateRowSorter(false);//дополняем сортировку
    menuList.setFillsViewportHeight(true);//заполняем всю область
    menuList.getTableHeader().setReorderingAllowed(false);//запрещаем двигать столбцы
    menuList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    
    menuList.setSurrendersFocusOnKeystroke(true);
         
    menuList.getModel().addTableModelListener(this);
    menuList.setDropMode(DropMode.ON_OR_INSERT_ROWS);
    menuList.setTransferHandler(new  MenuProductImportHandler(this));
    menuList.setDragEnabled(true);

    for (int i=0;i<menuList.getColumnCount();i++){
        if (i==0){
            menuList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getMenuNameWidth());
        }
        else if (i==1){
            menuList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getMenuWeightWidth());
        }
        else{
            menuList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getMenuRest());
        }
    }
    menuList.addMouseListener(popupListener);
    //menuList.setComponentPopupMenu(popup);
    setActionMap(menuList);

    if (settings.getIn().useSnack()){
        snackList = new JTable(new MenuTableModel(1,
            user.getFactors(),MenuTableModel.SNACK_TABLE)){
            //Implement table cell tool tips.
                @Override
            public String getToolTipText(MouseEvent e) {
                String tip = null;
                java.awt.Point p = e.getPoint();
                int rowIndex = rowAtPoint(p);
                int colIndex = columnAtPoint(p);
                if (rowIndex>=0 && colIndex>=0){
                    ProductInMenu prod = ((MenuTableModel)getModel()).getProduct(rowIndex);
                    tip = prod.getName() + "<br>";
                    DecimalFormat fr = new DecimalFormat("0.0");
                    tip += "Вес: " + fr.format(prod.getWeight()) + "<br>" +
                        " Б: " + fr.format(prod.getAllProt()) +
                        " Ж: " + fr.format(prod.getAllFat()) +
                        " У: " + fr.format(prod.getAllCarb()) +
                        " ГИ: " + prod.getGi();
                    
                }
                return tip;
            }
        };
        snackList.addKeyListener(menuKeyAdapter);
        snackList.setDefaultRenderer(Float.class, floatRenderer);
        snackList.getColumnModel().getColumn(1).setCellEditor(cellEditor0);
        
        snackList.setAutoCreateRowSorter(false);//дополняем сортировку
        snackList.setFillsViewportHeight(true);//заполняем всю область
        snackList.getTableHeader().setReorderingAllowed(false);//запрещаем двигать столбцы
        snackList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        
    
        snackList.setSurrendersFocusOnKeystroke(true);
        
        snackList.getModel().addTableModelListener(this);
        
        snackList.setDropMode(DropMode.ON_OR_INSERT_ROWS);
        snackList.setTransferHandler(new  MenuProductImportHandler(this));
        snackList.setDragEnabled(true);
        snackList.addMouseListener(popupListener);
        setActionMap(snackList);
        //snackList.setComponentPopupMenu(popup);
        for (int i=0;i<snackList.getColumnCount();i++){
            if (i==0){
                snackList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getMenuNameWidth());
            }
            else if (i==1){
                snackList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getMenuWeightWidth());
            }
            else{
                snackList.getColumnModel().getColumn(i).setPreferredWidth(settings.getIn().getMenuRest());
            }
        }
        menuList.addMouseListener(new MouseAdapter(){
          @Override
          public void mouseClicked(MouseEvent e) {
             if (SwingUtilities.isLeftMouseButton(e) &&
                     e.getClickCount() % 2 == 0)  {
                 ProductW prod = ((MenuTableModel)menuList.getModel()).getProductAtRow(
                         menuList.getSelectedRow());
                 ((MenuTableModel)snackList.getModel()).addProduct(prod);
                 }
          }
        });

        menuList.getColumnModel().addColumnModelListener(new TableColumnModelListener(){
            public void columnAdded(TableColumnModelEvent e){}
            public void columnRemoved(TableColumnModelEvent e){}
            public void columnMoved(TableColumnModelEvent e){}
            public void columnMarginChanged(ChangeEvent e){
                //System.out.println("Изменили ширину столбцов в меню");
                for (int i=0;i<snackList.getColumnCount();i++){
                    snackList.getColumnModel().getColumn(i).setPreferredWidth(
                            menuList.getColumnModel().getColumn(i).getWidth());
                }
            }
            public void columnSelectionChanged(ListSelectionEvent e){}
        });
        
    }
    if (snackList!=null){
        FocusAdapter ad =  new FocusAdapter(){
                @Override
            public void focusGained(FocusEvent e){
                if (e.getSource()==menuList) snackList.clearSelection();
                else if (e.getSource()==snackList) menuList.clearSelection();
               
           }
        };
        menuList.addFocusListener(ad);
        snackList.addFocusListener(ad);
    }
    AbstractAction startEditing = new AbstractAction() {
             public void actionPerformed(ActionEvent e) {
                if (e.getSource().equals(menuList)) {
                    int row = menuList.getSelectedRow();
                    int col = menuList.getSelectedColumn();
                    menuList.editCellAt(row, col);
                }
                else if (snackList!=null && e.getSource().equals(snackList)) {
                    int row = snackList.getSelectedRow();
                    int col = snackList.getSelectedColumn();
                    snackList.editCellAt(row, col);
                }
            }
    };   
    JComponent menuTableZone;
    if (snackList!=null){
        JPanel menu = new JPanel(new BorderLayout());
        JPanel snack = new JPanel(new BorderLayout());
        menu.add(new JScrollPane(menuList),BorderLayout.CENTER);
        snack.add(new JScrollPane(snackList),BorderLayout.CENTER);

        if (settings.getIn().showCarbRatio()){
            carbRatioMenu = new JProgressBar();
            Color bgr = carbRatioMenu.getBackground();
            carbRatioMenu.setPreferredSize(new Dimension(Short.MAX_VALUE,15));
            //carbRatioMenu.setString("Б:15,0 Ж:12,3 У:56,7 | ГИ 75 | ГН 38,6");
            carbRatioMenu.setStringPainted(true);
            carbRatioMenu.setOrientation(JProgressBar.HORIZONTAL);
            carbRatioMenu.setForeground(ALEX_GREEN);
            
            Color uiBgr = UIManager.getColor("ProgressBar.selectionBackground");
            Color uiFgr = UIManager.getColor("ProgressBar.selectionForeground");
            UIManager.put("ProgressBar.selectionBackground", uiFgr);
            UIManager.put("ProgressBar.selectionForeground", uiBgr);


            carbRatioSnack = new JProgressBar();
            carbRatioSnack.setPreferredSize(new Dimension(Short.MAX_VALUE,15));
            carbRatioSnack.setOrientation(JProgressBar.HORIZONTAL);
            carbRatioSnack.setForeground(bgr);
            carbRatioSnack.setStringPainted(true);
            //carbRatioSnack.setString("Б:15,0 Ж:12,3 У:56,7 | ГИ 75 | ГН 38,6");
            
            
            carbRatioSnack.setBackground(ALEX_GREEN);

            menu.add(carbRatioMenu,BorderLayout.SOUTH);
            snack.add(carbRatioSnack,BorderLayout.SOUTH);
        }
        
        menu_snack = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                menu,
                snack);
        menu_snack.setOneTouchExpandable(false);
        menu_snack.setDividerLocation(settings.getIn().getSnackSize());
        menuTableZone = menu_snack;
    }
    else menuTableZone = new JScrollPane(menuList);
    menuTblPane.add(menuTableZone,BorderLayout.CENTER);
    
    menuPane.add(menuTblPane,BorderLayout.CENTER);
    

    menuCalcPane.add(createCoefPane(),
            new GridBagConstraints(0,0,2,1,0.8,0.3,GridBagConstraints.CENTER,
                 GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0), 0,0));
    menuCalcPane.add(createDosesPane(),
            new GridBagConstraints(0,1,1,1,0.6,0.7,GridBagConstraints.CENTER,
                 GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0), 0,0));                 
    menuCalcPane.add(createCharPane(),
            new GridBagConstraints(1,1,1,2,0.2,0.7,GridBagConstraints.CENTER,
                 GridBagConstraints.BOTH,new Insets(0,0,0,0), 0,0));
    
    menuPane.add(menuCalcPane,BorderLayout.SOUTH);
    
    //menuPane.setMinimumSize(new Dimension(350,600));
    if (settings.getIn().getSize()==3) menuPane.setPreferredSize(new Dimension(320,600));
    else menuPane.setPreferredSize(new Dimension(350,600));
    return menuPane;
 }
  
 
 private JMenuBar createMenu(){
    JMenuBar menuBar;
    JMenu menu;
    JMenuItem menuItem;
    
    //Create the menu bar.
    menuBar = new JMenuBar();

    //Build the first menu.
    menu = new JMenu("Справка");
    
    
    menuItem = new JMenuItem("О программе");
    menuItem.addActionListener(this);
    menuItem.setActionCommand(SHOW_ABOUTBOX);
    menu.add(menuItem);
    menuBar.add(menu);
    
    menuBar.add(Box.createHorizontalGlue());
    menu = new JMenu("Выход");
    
    menuItem = new JMenuItem("Выход");
    menuItem.setActionCommand(PROG_EXIT);
    menuItem.addActionListener(this);
    menu.add(menuItem);
    menuBar.add(menu);

    menuBar.add(menu);
    
    return menuBar;
 }
 @Override
 public void tableChanged(TableModelEvent e) {
     if ( ((AbstractTableModel)e.getSource()).equals(menuList.getModel()) ||
             (snackList!=null&&((AbstractTableModel)e.getSource()).equals(snackList.getModel())  ) ){
         JTable tb;
         if ( ((MenuTableModel)e.getSource()).getTable()==MenuTableModel.MENU_TABLE )
             tb = menuList;
         else tb = snackList;
         int row = tb.getSelectedRow();
         if (row<(tb.getRowCount()-1)){
             tb.setRowSelectionInterval(row+1, row+1);
         }
         calcMenu();
     }
    
  }
 //Groups routine
 
 private void addNewGroup(){
     String s = (String)JOptionPane.showInputDialog(
                                        this,
                                        "Введите название группы:",
                                        "Добавление группы",
                                        JOptionPane.PLAIN_MESSAGE,
                                        null,
                                        null,
                                        "Новая группа");

                    //If a string was returned, say so.
                    if ((s != null) && (s.length() > 0)) {
                        s = s.trim();
                        //System.out.println("Введено: "+s);
                        ((GroupTableModel)grpList.getModel()).addGroup(new ProdGroup(0,s,0));
                        int n = grpList.getModel().getRowCount()-1;
                        Rectangle rect = grpList.getCellRect(n, 0, true);
                        grpList.scrollRectToVisible(rect);
                        grpList.getSelectionModel().setSelectionInterval(n,n);
                        baseIsChanged = true;
                    }
                    //else System.out.println("Ничего не введено");
                        
 }
 
 private void changeGroupName(){
     if (!grpList.getSelectionModel().isSelectionEmpty()){
     String s = (String)JOptionPane.showInputDialog(
                                        this,
                                        "Введите новое название группы:",
                                        "Изменение названия группы",
                                        JOptionPane.PLAIN_MESSAGE,
                                        null,
                                        null,
                                        ((GroupTableModel)grpList.getModel())
                                        .getValueAt(grpList.getSelectedRow(),0)
                                        );

                    //If a string was returned, say so.
                    if ((s != null) && (s.length() > 0)) {
                        s = s.trim();
                        ProdGroup gr = ((GroupTableModel)grpList.getModel())
                                .getGroup(grpList.getSelectedRow());
                        if (!s.equals(gr.getName())){
                            //System.out.println("Введено: "+s);
                            gr.setName(s);
                            int n = grpList.getSelectedRow();
                            ((GroupTableModel)grpList.getModel()).updateGroup(gr);
                            grpList.getSelectionModel().setSelectionInterval(n, n);
                            baseIsChanged = true;
                        }
                    }
                    //else System.out.println("Ничего не введено");
     }
 }
 
 private void deleteGroup(){
     if (!grpList.getSelectionModel().isSelectionEmpty()){
          Object[] options = {"Да", "Нет"};
          int n = JOptionPane.showOptionDialog(this,
                                    "Вы собираетесь удалить группу:\n\n" +
                                    grpList.getModel().getValueAt(grpList.getSelectedRow(),0)+
                                    "\n\n" +
                                    "Будут удалены все, входящие в нее, продукты\n"+
                                    "Удалить?",
                                    "Удаление группы",
                                    JOptionPane.YES_NO_OPTION,
                                    JOptionPane.WARNING_MESSAGE,
                                    null,
                                    options,
                                    options[1]);
                    if (n == JOptionPane.YES_OPTION) {
                        //System.out.println("Удаляем");
                        ProdGroup gr = ((GroupTableModel)grpList.getModel())
                                .getGroup(grpList.getSelectedRow());
                        int pos = grpList.getSelectedRow();
                        ((GroupTableModel)grpList.getModel()).deleteGroup(gr);
                        baseIsChanged = true;
                        if (grpList.getModel().getRowCount()>0)
                            if (pos>0) grpList.getSelectionModel().setSelectionInterval(pos-1, pos-1);
                            else grpList.getSelectionModel().setSelectionInterval(0, 0);
                        
                    }
          
     }
     
 }
 //Products routine
 private void addNewProd(){
    if (!grpList.getSelectionModel().isSelectionEmpty())
     if ( ((GroupTableModel)grpList.getModel()).getGroup(grpList.getSelectedRow()).getId()>
             (settings.getIn().useUsageGroup()-1)){
        prodDialog = new ProdDialog(this,null,groupMgr
             .getGroups(0),grpList.getSelectedRow());
     
        prodDialog.setModal(true);
        prodDialog.setVisible(true);
        if (prodDialog.getResult()){
             ProductInBase newProd = prodDialog.getProduct();
         
            ((ProductTableModel)prodList.getModel()).addProduct(newProd);
            //int id = prodMgr.getLastInsertedId();
         
            grpList.getSelectionModel().setSelectionInterval(prodDialog.getSelectedGroupIndex()+
                    settings.getIn().useUsageGroup(),
                 prodDialog.getSelectedGroupIndex()+settings.getIn().useUsageGroup());
            int row = prodList.convertRowIndexToView(((ProductTableModel)prodList
                 .getModel()).findRow(prodMgr.getLastInsertedId()));
            Rectangle rect = prodList.getCellRect(row, 0, true);
            prodList.scrollRectToVisible(rect);
            if (row>=0) prodList.getSelectionModel().setSelectionInterval(row, row);
            baseIsChanged = true;
        }
     }
     
 }
 
 private void editProduct(){
     if (!grpList.getSelectionModel().isSelectionEmpty())
     if ( ((GroupTableModel)grpList.getModel()).getGroup(grpList.getSelectedRow()).getId()>
             (settings.getIn().useUsageGroup()-1))
     {
        ProductInBase prod = ((ProductTableModel)prodList.getModel())
             .getProduct(prodList.convertRowIndexToModel(prodList.getSelectedRow()));
      
        prodDialog = new ProdDialog(this,prod,groupMgr
             .getGroups(0),grpList.getSelectedRow());
     
        prodDialog.setModal(true);
        prodDialog.setVisible(true);
        if (prodDialog.getResult()){
            int pos = prodList.convertRowIndexToModel(prodList.getSelectedRow());
            prod = prodDialog.getProduct();
            ((ProductTableModel)prodList.getModel()).updateProduct(prod);
            grpList.getSelectionModel().setSelectionInterval(prodDialog.getSelectedGroupIndex()+
                    settings.getIn().useUsageGroup(),
                 prodDialog.getSelectedGroupIndex()+settings.getIn().useUsageGroup());
            prodList.getSelectionModel().setSelectionInterval(pos, pos);
            //System.out.println("Продукт: "+prod.getName());
            baseIsChanged = true;
        }
      
     }
 }
 
 private void deleteProduct(){
     if (!grpList.getSelectionModel().isSelectionEmpty())
     if ( ((GroupTableModel)grpList.getModel()).getGroup(grpList.getSelectedRow()).getId()>
             (settings.getIn().useUsageGroup()-1) )
     {
     Object[] options = {"Да", "Нет"};
     int n = JOptionPane.showOptionDialog(this,
                                    "Вы собираетесь удалить продукт:\n\n" +
                                    prodList.getModel().getValueAt(prodList.getSelectedRow(),0)+
                                    "\n\n" +
                                    "Будут удалены все, входящие в него, продукты\n"+
                                    "Удалить?",
                                    "Удаление продукта",
                                    JOptionPane.YES_NO_OPTION,
                                    JOptionPane.WARNING_MESSAGE,
                                    null,
                                    options,
                                    options[1]);
                    if (n == JOptionPane.YES_OPTION) {
                        
                        int pos = prodList.convertRowIndexToModel(prodList.getSelectedRow());
                        ProductInBase prod = ((ProductTableModel)prodList.getModel())
                                .getProduct(pos);
                        /*System.out.println("Удаляем продукт "+prod.getName() +
                                " Поз в модели"+pos +"\nВ виде"
                                + prodList.getSelectedRow());
                        System.out.println("Кол-во объектов в компл ="+cmplList.getModel().getRowCount());*/
                        ((ProductTableModel)prodList.getModel()).deleteProduct(prod,pos);
                        //System.out.println("Прошли удаление простого");
                        if (prodList.getModel().getRowCount()>0){
                            if (pos==0) pos = 1;
                            prodList.getSelectionModel().setSelectionInterval(pos-1, pos-1);
                        }
                        baseIsChanged = true;
                    }
                    
     
     }
  
 }

 private void addProdToMenu(){
     if ((prodList.getRowCount()>0)&&
             (!prodList.getSelectionModel().isSelectionEmpty()))
     {
     ProductInBase prod = ((ProductTableModel)prodList.getModel()).getProduct(
             prodList.convertRowIndexToModel(prodList.getSelectedRow()));
     prod.setUsage(prod.getUsage()+1);
     prodMgr.updateProductInBase(prod);
     ((MenuTableModel)menuList.getModel()).addProduct(new ProductW(prod));
     }
 }
 private void addProdToSnack(){
     if ((prodList.getRowCount()>0)&&
             (!prodList.getSelectionModel().isSelectionEmpty()) && snackList!=null)
     {
     ProductInBase prod = ((ProductTableModel)prodList.getModel()).getProduct(
             prodList.convertRowIndexToModel(prodList.getSelectedRow()));
     prod.setUsage(prod.getUsage()+1);
     prodMgr.updateProductInBase(prod);
     ((MenuTableModel)snackList.getModel()).addProduct(new ProductW(prod));
     }
 }
 private void flushMenu(){
     if (menuList.getModel().getRowCount()>0 && !menuList.isEditing())
             ((MenuTableModel)menuList.getModel()).flushMenu();
     if (snackList!=null && snackList.getModel().getRowCount()>0 && !snackList.isEditing())
             ((MenuTableModel)snackList.getModel()).flushMenu();
 }
 
 private void createProductMenu(){
  if (!grpList.getSelectionModel().isSelectionEmpty())
  if ( ((GroupTableModel)grpList.getModel()).getGroup(grpList.getSelectedRow()).getId()==0 )
  {  
     grpList.getSelectionModel().setSelectionInterval(1, 1);
  }
     if (grpList.getRowCount()==0){
         JOptionPane.showMessageDialog(this, "Должна существовать хотя бы одна группа");
     }
     else if (((MenuTableModel)menuList.getModel()).getSumProd().getWeight()==0){
         JOptionPane.showMessageDialog(this, "Вес компонентов не может быть равен нулю");
     }
     else{
         ProductW prodW = ((MenuTableModel)menuList.getModel()).getSumProd();
         ProductInBase prod = new ProductInBase(
                 prodW.getName(),
                 prodW.getProt(),
                 prodW.getFat(),
                 prodW.getCarb(),
                 prodW.getGi(),
                 prodW.getWeight(),
                 0,
                 false,
                 ((GroupTableModel)grpList.getModel()).getGroup(
                    grpList.getSelectedRow()
                 ).getId(),
                 0
                 );
         prodDialog = new ProdDialog(this,prod,groupMgr
                 .getGroups(0),grpList.getSelectedRow());
     
     prodDialog.setModal(true);
     prodDialog.setVisible(true);
     if (prodDialog.getResult()){
         ProductInBase newProd = prodDialog.getProduct();
         
         ((ProductTableModel)prodList.getModel()).addProduct(newProd);
         grpList.getSelectionModel().setSelectionInterval(prodDialog.getSelectedGroupIndex()+
                 settings.getIn().useUsageGroup(),
                 prodDialog.getSelectedGroupIndex()+settings.getIn().useUsageGroup());
         int row = prodList.convertRowIndexToView(((ProductTableModel)prodList
                 .getModel()).findRow(prodMgr.getLastInsertedId()));
         Rectangle rect = prodList.getCellRect(row, 0, true);
         prodList.scrollRectToVisible(rect);
         if (prodList.getRowCount()>0) prodList.getSelectionModel().setSelectionInterval(0, 0);
         
     }
     }
 }
 
 
 
 private void deleteProdFromMenu(){
     if ( !menuList.getSelectionModel().isSelectionEmpty() && !menuList.isEditing() ){
           ((MenuTableModel)menuList.getModel()).deleteProduct(
             ((MenuTableModel)menuList.getModel()).getProduct(menuList.getSelectedRow()));

     }else if ( snackList!=null && !snackList.getSelectionModel().isSelectionEmpty() &&
             !snackList.isEditing()){
        ((MenuTableModel)snackList.getModel()).deleteProduct(
             ((MenuTableModel)snackList.getModel()).getProduct(snackList.getSelectedRow()));
     }
 }
 private User loadUser(){
     User user = null;
     if (new File(USER_CONF_FILE).exists()){
         try{
            XMLDecoder d = new XMLDecoder(
                     new BufferedInputStream(
                           new FileInputStream(USER_CONF_FILE)));
            user  = (User)d.readObject();
            d.close();
        }catch(Exception exc){
            user = new User();
        }
     }
     else user =  new User();
     return user;
 }
 public void saveUser(){
       // serialize the Queue
       try{
            XMLEncoder e = new XMLEncoder(
                          new BufferedOutputStream(
                              new FileOutputStream(USER_CONF_FILE)));
            e.writeObject(user);
            e.close();
        }catch (FileNotFoundException exc){
            System.out.println(exc.getLocalizedMessage());
        }

 }
 
 private void userChanged(){
     //Вот тут мы должны загрузить всю информацию по пользователю
     //изменить все зависимые поля и таблицы
     if (menuList!=null)
         menuList.getColumnModel().getColumn(1).getCellEditor().stopCellEditing();
     if (snackList!=null)
         snackList.getColumnModel().getColumn(1).getCellEditor().stopCellEditing();

     user = loadUser();
     
     if (lblXE!=null){
             if (user.isDirect())
                 lblXE.setText(("Кол. инс.<br>на k1 гр."));
             else
                 lblXE.setText(("Вес ХЕ"));
     }
        
     currDPS = new DPS(user.getTargetSh(),user.getTargetSh(),user.getFactors());
     //К этому времени уже должна существовать таблица, поэтому вначале проверяем
     //если нет, то инициализацию переменных делаем в блоке создания таблицы
     storeCoefs = false;
     
     if (menuList!=null){
        
        fldK1.setValue(user.getFactors().getK1(user.isDirect()));
        fldK2.setValue(user.getFactors().getK2());
        fldK3.setValue(new Sugar(user.getFactors().getK3()).getSugar(user.isMmol(),user.isPlasma()));
        fldXE.setValue(user.getFactors().getBE(user.isDirect()));
        fldSh1.setValue(user.getTargetSh().getSugar(user.isMmol(),user.isPlasma()));
        fldSh2.setValue(user.getTargetSh().getSugar(user.isMmol(),user.isPlasma()));
        ((MenuTableModel)menuList.getModel()).userChanged(user.getId());
        if (snackList!=null) ((MenuTableModel)snackList.getModel()).userChanged(user.getId());
        calcMenu();
     }
     storeCoefs = true;
     
 }
 

private void moveGroupUp(){
      //Передвигаем группу вверх
if ((grpList.getRowCount()>2)&&(grpList.getSelectedRow()>0))
 {
  int pos = grpList.getSelectedRow();
  int idLo = ((GroupTableModel)grpList.getModel()).getGroup(pos).getSortInd();
  int idHi = ((GroupTableModel)grpList.getModel()).getGroup(pos-1).getSortInd();

  ((GroupTableModel)grpList.getModel()).getGroup(pos).setSortInd(idHi);
  ((GroupTableModel)grpList.getModel()).getGroup(pos-1).setSortInd(idLo);

  
  
  ((GroupTableModel)grpList.getModel()).reloadGroups();
  grpList.getSelectionModel().setSelectionInterval(pos-1, pos-1);
  baseIsChanged = true;
 }
 }
 
 private void moveGroupDown(){
 if ((grpList.getRowCount()>2)&&(grpList.getSelectedRow()<(grpList.getRowCount()-1)))
 {
  int pos = grpList.getSelectedRow();
  int idHi = ((GroupTableModel)grpList.getModel()).getGroup(pos).getSortInd();
  int idLo = ((GroupTableModel)grpList.getModel()).getGroup(pos+1).getSortInd();

  ((GroupTableModel)grpList.getModel()).getGroup(pos).setSortInd(idLo);
  ((GroupTableModel)grpList.getModel()).getGroup(pos+1).setSortInd(idHi);

  
  
  ((GroupTableModel)grpList.getModel()).reloadGroups();
  grpList.getSelectionModel().setSelectionInterval(pos+1, pos+1);
  baseIsChanged = true;

 }
 }
 
 
 
 private void beginSearch(){
     ((CardLayout)productPanel.getLayout()).show(productPanel,SEARCH_PANE);
     
     searchFld.selectAll();
     searchFld.requestFocusInWindow();
 }
 
 private void cancelSearch(){
     ((CardLayout)productPanel.getLayout()).show(productPanel,PROD_PANE);
 }
 
 private void doSearch(){
     ((SearchTableModel)searchTable.getModel()).doSearch(searchFld.getText());
 }
 
 private void doSelectionSeached(){
     int sel = searchTable.getSelectedRow();
     int grInx = ((SearchTableModel)searchTable.getModel()).getGroup(sel).getId();
     int prInx = ((SearchTableModel)searchTable.getModel()).getProduct(sel).getId();
     int grRow;
     int prRow;
     if ( (grRow = ((GroupTableModel)grpList.getModel()).findRow(grInx))>=0 ){
            grpList.getSelectionModel().setSelectionInterval(grRow, grRow);
            if (  (prRow = prodList
                    .convertRowIndexToView(((ProductTableModel)prodList
                    .getModel()).findRow(prInx)) )>=0 ){
                
                Rectangle rect = prodList.getCellRect(prRow, 0, true);
                prodList.scrollRectToVisible(rect);
                prodList.getSelectionModel().setSelectionInterval(prRow, prRow);
            }
            
     }
     cancelSearch();
 }
 
 
 public JTable getProdTable(){
     return prodList;
 }

 

 private void showAboutBox(){
     AboutBox about = new AboutBox(new JFrame());
     about.setModal(true);
     about.setVisible(true);
 }
 
 public User getUser(){
     return user;
 }
 
 public String getMenuDescription(){
     String res = "";
     Vector<ProductW> menu = new Vector();
     Vector<ProductW> snack = new Vector();
     ProductW sum = new ProductW();
     DecimalFormat format = new DecimalFormat("0.0");

     if (menuList.getRowCount()>0 || (snackList!=null && snackList.getRowCount()>0)){
         for (int i=0;i<menuList.getRowCount();i++){
             menu.add( ((MenuTableModel)menuList.getModel()).getProductAtRow(i) );
             sum.plusProd(menu.get(i));
         }
         if (snackList!=null && snackList.getRowCount()>0){
             for (int i=0;i<snackList.getRowCount();i++){
                snack.add( ((MenuTableModel)snackList.getModel()).getProductAtRow(i) );
                sum.plusProd(snack.get(i));
             }
         }
         int max = 0;
         for (ProductW item:menu){
            max = item.getName().length()>max ? item.getName().length() : max;
         }
         for (ProductW item:snack){
            max = item.getName().length()>max ? item.getName().length() : max;
         }
         res += "Меню\n";
         for (ProductW item:menu){
                res += item.getName() + getSt(max-item.getName().length()+2,' ')+"\t"+
                        format.format(item.getWeight()) + "\t" +
                        format.format(item.getProt())+ "\t" +
                        format.format(item.getFat())+ "\t" +
                        format.format(item.getCarb())+ "\t" +
                        item.getGi() + "\n";
         }
         if (snackList!=null && snackList.getRowCount()>0) res += "Перекус" + getSt(max+22,'~') + "\n";
         for (ProductW item:snack){
                res += item.getName() + getSt(max-item.getName().length()+2,' ')+"\t"+
                        format.format(item.getWeight()) + "\t" +
                        format.format(item.getProt())+ "\t" +
                        format.format(item.getFat())+ "\t" +
                        format.format(item.getCarb())+ "\t" +
                        item.getGi() + "\n";
         }
         res += getSt(max+29,'~')+"\n";
         res += "Кал:"+format.format(sum.getCalories())+
                    " Б:"+format.format(sum.getAllProt()) +
                    " Ж:"+format.format(sum.getAllFat()) +
                    " У:"+format.format(sum.getAllCarb()) +
                    " ГИ:"+sum.getGi() +
                    " ГН:"+format.format(sum.getGL()) +"\n";
         res += getSt(max+29,'~') + "\n";
         res += "k1=" + format.format(user.getFactors().getK1(user.isDirect())) +
                 " k2=" + format.format(user.getFactors().getK2());
         if (!user.isDirect()) res += " ХЕ="+user.getFactors().getBE(user.isDirect());
         if (currDPS.getSh1().getValue()!=currDPS.getSh2().getValue()){
             res += " СКнач=" + format.format(currDPS.getSh1().getSugar(user.isMmol(), user.isPlasma())) +
                    " СКцель=" + format.format(currDPS.getSh2().getSugar(user.isMmol(), user.isPlasma())) +
                    " ЦЕИ=" + format.format(
                                new Sugar(user.getFactors().getK3())
                                .getSugar(user.isMmol(), user.isPlasma()));
         }
         res += "\n" + getSt(max+29,'~') + "\n";
         Dose ds = new Dose(sum,user.getFactors(),currDPS);
         res += "ДПС+БД=" + format.format(ds.getDPSDose()+ds.getCarbFastDose()) + " МДугл+МДбел/ж=" +
                format.format(ds.getCarbSlowDose()+ds.getSlowDose()) + 
                " Вся доза =" + format.format(ds.getWholeDose()) + "\n";
     }
     return res;
  
 }
 private String getSt(int n,char c){
        String st = "";
        for(int i=0;i<n;i++){
            st += c;
        }
        return st;
 }

 private void roundDose(){
     if ( !menuList.getSelectionModel().isSelectionEmpty() ||
             (snackList!=null && !snackList.getSelectionModel().isSelectionEmpty() )){
         ProductW prod;
         ProductInMenu prodMenu;
         if (menuList.getSelectionModel().isSelectionEmpty()){
             prod = ((MenuTableModel)snackList.getModel())
                     .getProductAtRow(snackList.getSelectedRow());
             prodMenu = ((MenuTableModel)snackList.getModel())
                     .getProduct(snackList.getSelectedRow());
         } else{
             prod = ((MenuTableModel)menuList.getModel())
                     .getProductAtRow(menuList.getSelectedRow());
             prodMenu = ((MenuTableModel)menuList.getModel())
                     .getProduct(menuList.getSelectedRow());
         }
         ProductW sum = ((MenuTableModel)menuList.getModel()).getSumProd();
         if (snackList!=null) sum.plusProd(((MenuTableModel)snackList
                 .getModel()).getSumProd());
         Dose ds_now = new Dose(sum,user.getFactors(),currDPS);
         ProductW prod100 = new ProductW(prod);
         prod100.setWeight(prod.getWeight()+100f);
         
         //Dose ds_100 = new Dose(sum,user.getFactors(),currDPS);
         double dose_diff = new Dose(prod100,user.getFactors(),currDPS).getWholeDose() -
                    new Dose(prod,user.getFactors(),currDPS).getWholeDose();
         
         double frac = ds_now.getWholeDose() - Math.floor(ds_now.getWholeDose());
         //System.out.println( dose_diff);
         //System.out.println(frac);
         double step;
         switch (settings.getIn().getRoundLimit()){
             case 0: step = 1;
                        break;
                case 1: step = 0.5;
                        break;
                case 2: step = 0.25;
                        break;
                case 3: step = 0.1;
                        break;
                case 4: step = 0.5/6;
                        break;
                case 5: step = 0.05;
                        break;
                default: step = 1;
         }
         double i = 0;
         while (i<frac)
                i += step;
         double upDiff = Math.floor( ds_now.getWholeDose() ) + i -
                 (double)ds_now.getWholeDose();
         double downDiff = (double)ds_now.getWholeDose() -
                 Math.floor( ds_now.getWholeDose() ) - (i-step);

          double wUp = upDiff * 100 / dose_diff;
          double wDown = downDiff * 100 / dose_diff;
          //System.out.println("Прибавить :"+wUp);
          //System.out.println("отнять :" + wDown);
          DecimalFormat fr = new DecimalFormat("0.00");
          Object[] options = {new String("+"+fr.format(wUp))+" г.","Отмнена",
                new String("-"+fr.format(wDown)+" г.")};

          int n = JOptionPane.showOptionDialog(this,
                                    "Округлить дозу по весу продукта\n"+
                                    prod.getName() +
                                    "\n\nПредел округления: " + ROUNDS[settings.getIn().getRoundLimit()],
                                    "Округление дозы",
                                    JOptionPane.YES_NO_CANCEL_OPTION,
                                    JOptionPane.QUESTION_MESSAGE,
                                    null,
                                    options,
                                    options[1]);
                    if (n == JOptionPane.YES_OPTION) {//Ответили, что увеличиваем
                        prodMenu.setWeight(prodMenu.getWeight()+(float)wUp);
                        if (menuList.getSelectionModel().isSelectionEmpty()){
                            ((MenuTableModel)snackList.getModel())
                                    .updateProduct(prodMenu);
                            
                        } else{
                            ((MenuTableModel)menuList.getModel())
                                    .updateProduct(prodMenu);
                        }
                    }
                    else if  (n == JOptionPane.CANCEL_OPTION) {//Ответили, что уменьшаем
                        prodMenu.setWeight(prodMenu.getWeight()-(float)wDown);
                        if (menuList.getSelectionModel().isSelectionEmpty()){
                            ((MenuTableModel)snackList.getModel())
                                    .updateProduct(prodMenu);

                        } else{
                            ((MenuTableModel)menuList.getModel())
                                    .updateProduct(prodMenu);
                        }
                    }
     }
 }
 
 protected ImageIcon loadImage(String name){
        String path = name;
        int MAX_IMAGE_SIZE = 2000;  //Change this to the size of
                                     //your biggest image, in bytes.
        int count = 0;
        BufferedInputStream imgStream = new BufferedInputStream(
           this.getClass().getResourceAsStream(path));
        if (imgStream != null) {
            byte buf[] = new byte[MAX_IMAGE_SIZE];
            try {
                count = imgStream.read(buf);
                imgStream.close();
            } catch (java.io.IOException ioe) {
                System.err.println("Couldn't read stream from file: " + path);
                return null;
            }
            if (count <= 0) {
                System.err.println("Empty file: " + path);
                return null;
            }
            return new ImageIcon(Toolkit.getDefaultToolkit().createImage(buf));
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }
 
 AbstractAction move2menu = new AbstractAction(){
     @Override
     public void actionPerformed(ActionEvent e) {
		menuList.requestFocusInWindow();
        final Color f = menuList.getForeground();
        final Color b = menuList.getBackground();
        menuList.setForeground(b);
        menuList.setBackground(f);

        Thread t = new Thread() {
            public void run(){
                try{
                    Thread.sleep(200);
                } catch (Exception ex) {}

                menuList.setForeground(f);
                menuList.setBackground(b);

            }
        };
        t.start();
        if (menuList.getSelectionModel().isSelectionEmpty()&&menuList.getRowCount()>0)
            menuList.getSelectionModel().setSelectionInterval(0, 0);
     }
 };

 AbstractAction move2group = new AbstractAction(){
     @Override
     public void actionPerformed(ActionEvent e) {
		grpList.requestFocusInWindow();
        final Color f = grpList.getForeground();
        final Color b = grpList.getBackground();
        grpList.setForeground(b);
        grpList.setBackground(f);
        
        Thread t = new Thread() {
            public void run(){
                try{
                    Thread.sleep(300);
                } catch (Exception ex) {}

                grpList.setForeground(f);
                grpList.setBackground(b);

            }
        };
        t.start();
        if (grpList.getSelectionModel().isSelectionEmpty()&&grpList.getRowCount()>0)
            grpList.getSelectionModel().setSelectionInterval(0, 0);
     }
 };
 AbstractAction move2prod = new AbstractAction(){
     @Override
     public void actionPerformed(ActionEvent e) {
		prodList.requestFocusInWindow();
        final Color f = prodList.getForeground();
        final Color b = prodList.getBackground();
        prodList.setForeground(b);
        prodList.setBackground(f);

        Thread t = new Thread() {
            public void run(){
                try{
                    Thread.sleep(300);
                } catch (Exception ex) {}

                prodList.setForeground(f);
                prodList.setBackground(b);

            }
        };
        t.start();
        if (prodList.getSelectionModel().isSelectionEmpty()&&prodList.getRowCount()>0)
            prodList.getSelectionModel().setSelectionInterval(0, 0);
     }
 };
 
 AbstractAction move2snack = new AbstractAction(){
     @Override
     public void actionPerformed(ActionEvent e) {
		if (snackList!=null){
         snackList.requestFocusInWindow();
         final Color f = snackList.getForeground();
         final Color b = snackList.getBackground();
         snackList.setForeground(b);
         snackList.setBackground(f);

        Thread t = new Thread() {
            public void run(){
                try{
                    Thread.sleep(300);
                } catch (Exception ex) {}

                snackList.setForeground(f);
                snackList.setBackground(b);

            }
        };
        t.start();
         if (snackList.getSelectionModel().isSelectionEmpty()&&snackList.getRowCount()>0)
            snackList.getSelectionModel().setSelectionInterval(0, 0);
        }
     }
 };
}//Конец главного класса
