/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lookout;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */
import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import java.text.ParseException;
import java.text.DecimalFormatSymbols;
import maths.Calculator;

public class PositiveFloatVerifier extends InputVerifier {
    private boolean calc;
    private DecimalFormatSymbols symbols = new DecimalFormatSymbols();
    private Calculator calculator;
    public PositiveFloatVerifier(boolean calc){
        this.calc = calc;
        symbols = new DecimalFormatSymbols();
        calculator = new Calculator();
    }

    @Override
    public boolean verify(JComponent input) {
             if (input instanceof JFormattedTextField) {
             JFormattedTextField ftf = (JFormattedTextField)input;
             JFormattedTextField.AbstractFormatter formatter = ftf.getFormatter();
             if (formatter != null) {
                 String text = ftf.getText().replace(',', symbols.getDecimalSeparator())
                         .replace('.', symbols.getDecimalSeparator());
                 if (!text.equals(ftf.getText())){
                     ftf.setText(text);
                     //System.out.println("text setted");
                 }
                 if (calc){
                    String text_calced = calculator.Calc(text,formatter);
                    if (!text_calced.equals(text)){
                        try{
                            //Проверяем проходит ли парсинг, но value не меняем
                            ((Number)formatter.stringToValue(text)).floatValue();
                        }catch (ParseException pe){
                        return false;
                        }
                        ftf.setText(text_calced);
                        ftf.setCaretPosition(ftf.getText().length());
                        text = text_calced;
                    }

                 }
                 try {
                      float vl = ((Number)formatter.stringToValue(text)).floatValue();
                      if (vl<0.0f) ftf.setValue(0f);
                      else ftf.setValue(vl);
                      ftf.setCaretPosition(ftf.getText().length());
                  } catch (ParseException pe) {
                      return false;
                  }
              }
          }

          return true;
  }

  @Override
  public boolean shouldYieldFocus(JComponent input) {
          return verify(input);
  }


}
