/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package manager;

/**
 *
 * @author connie
 */







import java.util.*;
import products.*;

import java.io.*;

public class ManagementSystem {
    private final static String LOCAL_BASE = System.getProperty("user.home")+File.separator+".food.db";
    private Vector<ProdGroup> groups;
    private Vector<ProductInBase> products;
    private Vector<ProductInMenu> menu_prods,snack_prods;
    private int id_group = 0;
    private int id_prod = 0;
    private int id_menu = 0;
    private int id_snack = 0;
    //private static Connection con;

    private static ManagementSystem instance = null;
    
    public int getNextidGr(){
        System.out.println(id_group);
        return ++id_group;
    }
    public int getNextidPr(){
        return ++id_prod;
    }
    public int getNextidMenu(){
        return ++id_menu;
    }
    public int getNextidSnack(){
        return ++id_snack;
    }
    
    private ManagementSystem() {
        menu_prods = new Vector();
        snack_prods = new Vector();
        groups = new Vector();
        products = new Vector();
        //вот тут загружаем базу из файла
        readFile();
  }
     
  public static synchronized ManagementSystem getInstance(){
    if (instance == null) {
      instance = new ManagementSystem();
    }
    return instance;
  }
   
 public void saveBase(Collection groups,Collection prods){
        File flConf = new File(LOCAL_BASE);
        try{
              BufferedWriter r = new BufferedWriter( new OutputStreamWriter
                                        ( new FileOutputStream( flConf ),"UTF8"));
              r.write("<MENU>\n");
              for(Object it:groups){
                  ProdGroup gr = (ProdGroup)it;
                  r.write(gr.getName()+"\t"+gr.getId()+"\n");
              }
              r.write("<DATA>\n");
              for(Object it:prods){
                  ProductInBase pr = (ProductInBase)it;
                  r.write(pr.getName()+"\t"+pr.getProt()+"\t"+pr.getFat()+"\t"+
                          pr.getCarb()+"\t"+pr.getGi()+"\t"+pr.getOwner()+"\n");
              }
              r.close();
        }catch(IOException ex){}
 }
 
 private void readFile(){
    //тут проверяем наличие файла локального, если нет его, то читаем из jar
     InputStream is = null;
     if (new File(LOCAL_BASE).exists()){
         try{
            is = new FileInputStream(LOCAL_BASE);
         }catch (IOException ex){
             ex.printStackTrace();
             is = this.getClass().getResourceAsStream("base/food.db");
         }

     }else{
         is = this.getClass().getResourceAsStream("base/food.db");
     }
        
        BufferedReader br = null;
        String line = "";
        String list = "";
        int sort_ind = 1;

    try {
      br = new BufferedReader(new InputStreamReader(is,"UTF8"));
      if (((line = getNextLine(br))!=null)&&(line.contains("<MENU>"))){
          while (((line=getNextLine(br))!=null)&&(!line.equals("<DATA>"))){
              //тут создаем массив групп
              ProdGroup gbuf = getGroup(line);
              gbuf.setSortInd(sort_ind++);
              if (gbuf.getId()>id_group) id_group = gbuf.getId();
              groups.add(gbuf);
          }
          while ((line=getNextLine(br))!=null){
              //тут создаем массив продуктов
              ProductInBase prod = getProduct(line);
              prod.setId(getNextidPr());
              products.add(prod);
          }
          
      }
      
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    finally {
      try {
        if (br != null) br.close();
        if (is != null) is.close();
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }

 }

 public Vector<ProdGroup> getGroups(){
     return groups;
 }
 public Vector<ProductInBase> getProducts(){
     return products;
 }
 
 public Vector<ProductInMenu> getMenu(){
     return menu_prods;
 }
 
 public Vector<ProductInMenu> getSnack(){
     return snack_prods;
 }
 
 private ProdGroup getGroup(String st){
     String idGr = "";
     int i;
     for (i=st.length()-1;i>=0;i--){
         if ((st.charAt(i)==';')||(st.charAt(i)=='\t')  ) break;
         else  idGr = st.charAt(i)+idGr;
     }
     return new ProdGroup( Integer.parseInt(idGr) , st.substring(0, i).trim() ,  0);
 }
 
 private ProductInBase getProduct(String st){
     String idGr = "";
     String protSt = "";
     String fatSt = "";
     String carbSt = "";
     String giSt = "";
     int i=st.length()-1;
     while ( (!((st.charAt(i)==';')||(st.charAt(i)=='\t'))) &&(i>=0) ){
         idGr = st.charAt(i--) + idGr;
     }
     i--;
     while ( (!((st.charAt(i)==';')||(st.charAt(i)=='\t'))) &&(i>=0) ){
         giSt = st.charAt(i--) + giSt;
     }
     i--;
     while ( (!((st.charAt(i)==';')||(st.charAt(i)=='\t'))) &&(i>=0) ){
         carbSt = st.charAt(i--) + carbSt;
     }
     i--;
     while ( (!((st.charAt(i)==';')||(st.charAt(i)=='\t'))) &&(i>=0) ){
         fatSt = st.charAt(i--) + fatSt;
     }
     i--;
     while ( (!((st.charAt(i)==';')||(st.charAt(i)=='\t'))) &&(i>=0) ){
         protSt = st.charAt(i--) + protSt;
     }
    
     String name = st.substring(0, i).trim();
     
     return new ProductInBase(name,Float.parseFloat(protSt),
             Float.parseFloat(fatSt),Float.parseFloat(carbSt),(int)Float.parseFloat(giSt),
             100,0,false,Integer.parseInt(idGr),0);
 }
 
 private String getNextLine(BufferedReader r){
     String l = null;
     try{
        l = r.readLine();
     } catch(IOException e){System.out.println(e.getMessage());}
     if (l!=null) l = l.trim();
     return l;
 }
}
