/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tablemodels;

/**
 *
 * @author connie
 */
import lookout.settings.ProgramSettings;
import products.ProductW;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

import maths.*;


import products.ProductInMenu;
import manager.MenuManager;

public class MenuTableModel extends AbstractTableModel {
    public final static int MENU_TABLE = 0;
    public final static int SNACK_TABLE = 1;

    public final static int CALOR = 1;
    public final static int DOSE = 2;
    public final static int PROT = 4;
    public final static int FAT = 8;
    public final static int CARB = 16;
    public final static int Gi = 32;
    public final static int GL = 64;
    
    private Vector products;
    private ProgramSettings settings;
   
    private Dose ds;
    //private DPS dps;
    private Factors factors;
    private MenuManager mgr;
    private int table;

    private String [] colNames = { "Наименование", "Вес", "Калор", "Доза",
                "Б","Ж","У","ГИ","ГН"};
    private int colCount;
    private int [] colReplace = new int[9];
    
    public MenuTableModel(int idUser,Factors factors,
            int table){
         settings = ProgramSettings.getInstance();
         initModelStructure();
         this.factors = factors;
         //this.dps = dps;
         this.table = table;
         
         mgr = new MenuManager(idUser,table);
         products = new Vector(mgr.getMenu());
         
         
    }
    public int getTable(){
        return table;
    }
    public void changeStructure(){
        initModelStructure();
        fireTableStructureChanged();
    }
    private void initModelStructure(){
        int mask = settings.getIn().getMenuMask();
        colCount = 2 + (mask&CALOR) + ((mask&DOSE)>>1) + ((mask&PROT)>>2) +
                ((mask&FAT)>>3) + ((mask&CARB)>>4) + ((mask&Gi)>>5) + ((mask&GL)>>6);
        //System.out.println("columns="+colCount + " " + mask);
        colReplace[0] = 0;
        colReplace[1] = 1;
        //int bit = 1;
        int j = 2;
        int i = 2;
        for (int bit=1;bit<=GL;bit *=2){
            if ( (mask&bit)!=0 ){
                colReplace[j] = i;
                j++;
            }
            i++;
        }
    }
    public void userChanged(int idUser){
        mgr = new MenuManager(idUser,table);
        products = new Vector(mgr.getMenu());
        fireTableDataChanged();
    }
  
  @Override
  public int getRowCount()
  {
    if (products != null) {
      return products.size();
    }
    return 0;
  }
  
  // Количество столбцов - 6
  @Override
  public int getColumnCount()
  {
    return colCount;
    //return 4;
  }

  // Вернем наименование колонки
  @Override
  public String getColumnName(int column)
  {
     if (table==1) return null;
     else return colNames[colReplace[column]];
  }

  // Возвращаем данные для определенной строки и столбца
  @Override
  public Object getValueAt(int rowIndex, int columnIndex){
    if (products != null) {
      // Получаем из вектора студента
      ProductW prod = (ProductW) products.get(rowIndex);
      ds = new Dose(prod,factors,new DPS());
      int c = colReplace[columnIndex];
      switch (c) {
          case 0: return prod.getName();

          case 1: return prod.getWeight();

          case 2: return ds.getCalories();

          case 3: return ds.getWholeDose();

          case 4: return prod.getAllProt();

          case 5: return prod.getAllFat();
      
          case 6: return prod.getAllCarb();

          case 7: return prod.getGi();
          
          case 8: return prod.getGL();

        //ds.getWholeDose()-ds.getDPSDose(); по идее нужно так, но ДПС здесь всегда равна
        //нулю, поэтому она не вычитается
        //  case 4: return 4f;
      }
    }
    return null;
  }
  
  @Override
  public void setValueAt(Object value, int row, int col){
      if (col==1){
        System.out.println("table "+value);
        ProductInMenu prod = (ProductInMenu)products.get(row);
        prod.setWeight(((Number)value).floatValue());
        mgr.updateProd(prod);
      
        fireTableRowsUpdated(row,row);
      }
  }
  
  
  
  public ProductW getProductAtRow(int Row){
      if ((products!=null)&&(Row<products.size())){
          return (ProductW)products.get(Row);
      }
      return null;
  }
   public ProductW getSumProd(){
      if (products!=null){
          ProductW res = new ProductW();
          for (Object item : products) {
             res.plusProd((ProductW)item);
          }
          return res;
      }
      return null;
  }
   
  
  
  
  public void setFactors(Factors fcs){
      this.factors = fcs;
      if (products!=null && products.size()>0) this.fireTableDataChanged();
      //if ((products!=null) && (products.size()>0))
        //  this.fireTableRowsUpdated(0, products.size()-1);
  }
 
  /*
         * JTable uses this method to determine the default renderer/
         * editor for each cell.  If we didn't implement this method,
         * then the last column would contain text ("true"/"false"),
         * rather than a check box.
         */
  @Override
  public Class getColumnClass(int c) {
     return getValueAt(0, c).getClass();
     
  }    
  
  /*
     * Don't need to implement this method unless your table's
     * editable.
     */
  @Override  
  public boolean isCellEditable(int row, int col) {
        //Note that the data/cell address is constant,
        //no matter where the cell appears onscreen.
        return col==1;
  }
    
   public ProductInMenu getProduct(int rowIndex)
   {
    if(products!=null) {
      if(rowIndex<products.size() && rowIndex>=0) {
          
        return (ProductInMenu)products.get(rowIndex);
      }
    }
     return null;
   }   
    
    public void addProduct(ProductW prod){
        boolean found = false;
        for (Object item:products.toArray() ){
            if (((ProductW)item).getName().equals(prod.getName())){
                found=true;
                break;
            }
        }
        if (!found){
            prod.setWeight(0f);
            products = new Vector(mgr.addProd(prod));
            fireTableDataChanged();
        }
    }

    public void insertProduct(ProductW prod){
        boolean found = false;
        for (Object item:products.toArray() ){
            if (((ProductW)item).getName().equals(prod.getName())){
                found=true;
                break;
            }
        }
        if (!found){
            //prod.setWeight(0f);
            products = new Vector(mgr.addProd(prod));
            fireTableDataChanged();
        }
    }
    public void flushMenu(){
        if (products.size()>0){
            int n = products.size();
            products = new Vector(mgr.flush());
            fireTableRowsDeleted(0,n-1);
         }
    }
    
    public void deleteProduct(ProductInMenu prod){
        if (products.size()>0){
            products = new Vector(mgr.deleteProd(prod));
            //fireTableRowsDeleted(pos-1,pos-1);
            if (products.size()>0) fireTableDataChanged();
            else fireTableRowsDeleted(0,0);
        }
    }
    public void updateProduct(ProductInMenu prod){
        if (products.size()>0){
            products = new Vector(mgr.updateProd(prod));
            if (products.size()>0) fireTableDataChanged();
        }
    }
}
