/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tablemodels;

/**
 *
 * @author connie
 */
import lookout.settings.ProgramSettings;
import lookout.*;
import java.util.Vector;
import javax.swing.table.AbstractTableModel;


import manager.SearchProdManager;
import products.Pair;
import products.ProdGroup;
import products.ProductInBase;

public class SearchTableModel  extends AbstractTableModel {
    private SearchProdManager mgr;
    private Vector searchResults;
    private ProgramSettings settings;
    
    public SearchTableModel(){
        settings = ProgramSettings.getInstance();
        mgr = new SearchProdManager();
        searchResults = new Vector(mgr.doSearch(""));
    }
    
  public int getRowCount()
  {
    if (searchResults!= null) {
      return searchResults.size();
    }
    return 0;
  }
  // Количество столбцов - 6
  public int getColumnCount()
  {
    return 6;
  }
  // Вернем наименование колонки
  public @Override String getColumnName(int column)
  {
    String[] colNames = {"Группа","Наименование", "Б", "Ж", "У","ГИ" };
    return colNames[column];
  }
   // Возвращаем данные для определенной строки и столбца
  public Object getValueAt(int rowIndex, int columnIndex)
  {
    if (searchResults != null)  {
      // Получаем из вектора студента
      Pair pair = (Pair)searchResults.get(rowIndex);
      //ComplexProduct prod = (ComplexProduct) composition.get(rowIndex);

      switch (columnIndex) {
      case 0://Наименование группы
        return pair.getGroup().getName();

      case 1://Наименование продукта
        return pair.getProduct().getName();

      case 2://Б
        return pair.getProduct().getProt();
        
      case 3://Ж
        return pair.getProduct().getFat();

      case 4://У
        return pair.getProduct().getCarb();
        
      case 5:
        return pair.getProduct().getGi();

      }
    }
    return null;

  }
  @Override
  public Class getColumnClass(int c) {
      if (searchResults!=null && searchResults.size()>0 ) 
          return getValueAt(0, c).getClass();
      else return null;
  }
  public void doSearch(String st){
      int sz = searchResults.size();
      searchResults = new Vector(mgr.doSearch(st));
      if (searchResults.size()>0) fireTableDataChanged();
      else if (sz>0) fireTableRowsDeleted(0,sz-1);
  }
  
  public ProdGroup getGroup(int rowInx){
      if (searchResults.size()>0){
        Pair pr = (Pair)searchResults.get(rowInx);
        return pr.getGroup();
      } else return null;
  }
  
  public ProductInBase getProduct(int rowInx){
      if (searchResults.size()>0){
        Pair pr = (Pair)searchResults.get(rowInx);
        return pr.getProduct();
      } else return null;
  }
}
